/* number-picker.c generated by valac 0.56.4, the Vala compiler
 * generated from number-picker.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
enum  {
	NUMBER_PICKER_0_PROPERTY,
	NUMBER_PICKER_NUM_PROPERTIES
};
static GParamSpec* number_picker_properties[NUMBER_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
enum  {
	NUMBER_PICKER_NUMBER_PICKED_SIGNAL,
	NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL,
	NUMBER_PICKER_NUM_SIGNALS
};
static guint number_picker_signals[NUMBER_PICKER_NUM_SIGNALS] = {0};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _NumberPickerPrivate {
	SudokuBoard* board;
	GtkButton* clear_button;
	gint earmarks_active;
};

struct _Block5Data {
	int _ref_count_;
	NumberPicker* self;
	gint n;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	GtkToggleButton* toggle_button;
};

static gint NumberPicker_private_offset;
static gpointer number_picker_parent_class = NULL;

VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _________lambda4_ (Block5Data* _data5_);
static void __________lambda4__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _________lambda5_ (Block6Data* _data6_);
static void __________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                   gpointer self);
static void ___lambda6_ (NumberPicker* self);
static void ____lambda6__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static GtkToggleButton* number_picker_get_button_for (NumberPicker* self,
                                               gint number);
static void g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void number_picker_finalize (GObject * obj);
static GType number_picker_get_type_once (void);

static inline gpointer
number_picker_get_instance_private (NumberPicker* self)
{
	return G_STRUCT_MEMBER_P (self, NumberPicker_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/number-picker.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "number-picker.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 42 "../src/number-picker.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 42 "../src/number-picker.vala"
	return _data5_;
#line 162 "number-picker.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 42 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 172 "number-picker.c"
		NumberPicker* self;
#line 42 "../src/number-picker.vala"
		self = _data5_->self;
#line 42 "../src/number-picker.vala"
		_g_object_unref0 (self);
#line 42 "../src/number-picker.vala"
		g_slice_free (Block5Data, _data5_);
#line 180 "number-picker.c"
	}
}

static void
_________lambda4_ (Block5Data* _data5_)
{
	NumberPicker* self;
#line 60 "../src/number-picker.vala"
	self = _data5_->self;
#line 61 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, _data5_->n);
#line 192 "number-picker.c"
}

static void
__________lambda4__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self)
{
#line 60 "../src/number-picker.vala"
	_________lambda4_ (self);
#line 201 "number-picker.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 59 "../src/number-picker.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 59 "../src/number-picker.vala"
	return _data6_;
#line 211 "number-picker.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 59 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 221 "number-picker.c"
		NumberPicker* self;
#line 59 "../src/number-picker.vala"
		self = _data6_->_data5_->self;
#line 59 "../src/number-picker.vala"
		_g_object_unref0 (_data6_->toggle_button);
#line 59 "../src/number-picker.vala"
		block5_data_unref (_data6_->_data5_);
#line 59 "../src/number-picker.vala"
		_data6_->_data5_ = NULL;
#line 59 "../src/number-picker.vala"
		g_slice_free (Block6Data, _data6_);
#line 233 "number-picker.c"
	}
}

static void
_________lambda5_ (Block6Data* _data6_)
{
	Block5Data* _data5_;
	NumberPicker* self;
	gboolean toggle_active = FALSE;
	GtkToggleButton* _tmp0_;
#line 66 "../src/number-picker.vala"
	_data5_ = _data6_->_data5_;
#line 66 "../src/number-picker.vala"
	self = _data5_->self;
#line 67 "../src/number-picker.vala"
	_tmp0_ = _data6_->toggle_button;
#line 67 "../src/number-picker.vala"
	toggle_active = gtk_toggle_button_get_active (_tmp0_);
#line 68 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, _data5_->n, toggle_active);
#line 254 "number-picker.c"
}

static void
__________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self)
{
#line 66 "../src/number-picker.vala"
	_________lambda5_ (self);
#line 263 "number-picker.c"
}

static void
___lambda6_ (NumberPicker* self)
{
#line 91 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, 0);
#line 271 "number-picker.c"
}

static void
____lambda6__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 90 "../src/number-picker.vala"
	___lambda6_ ((NumberPicker*) self);
#line 280 "number-picker.c"
}

NumberPicker*
number_picker_construct (GType object_type,
                         SudokuBoard** board,
                         gboolean earmark)
{
	NumberPicker * self = NULL;
	SudokuBoard* _tmp0_;
#line 35 "../src/number-picker.vala"
	g_return_val_if_fail (*board != NULL, NULL);
#line 35 "../src/number-picker.vala"
	self = (NumberPicker*) g_object_new (object_type, NULL);
#line 37 "../src/number-picker.vala"
	_tmp0_ = _g_object_ref0 (*board);
#line 37 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 37 "../src/number-picker.vala"
	self->priv->board = _tmp0_;
#line 38 "../src/number-picker.vala"
	self->priv->earmarks_active = 0;
#line 302 "number-picker.c"
	{
		gint col = 0;
#line 40 "../src/number-picker.vala"
		col = 0;
#line 307 "number-picker.c"
		{
			gboolean _tmp1_ = FALSE;
#line 40 "../src/number-picker.vala"
			_tmp1_ = TRUE;
#line 40 "../src/number-picker.vala"
			while (TRUE) {
#line 314 "number-picker.c"
				gint _tmp3_;
				gint _tmp4_;
#line 40 "../src/number-picker.vala"
				if (!_tmp1_) {
#line 319 "number-picker.c"
					gint _tmp2_;
#line 40 "../src/number-picker.vala"
					_tmp2_ = col;
#line 40 "../src/number-picker.vala"
					col = _tmp2_ + 1;
#line 325 "number-picker.c"
				}
#line 40 "../src/number-picker.vala"
				_tmp1_ = FALSE;
#line 40 "../src/number-picker.vala"
				_tmp3_ = sudoku_board_get_block_cols (*board);
#line 40 "../src/number-picker.vala"
				_tmp4_ = _tmp3_;
#line 40 "../src/number-picker.vala"
				if (!(col < _tmp4_)) {
#line 40 "../src/number-picker.vala"
					break;
#line 337 "number-picker.c"
				}
				{
					gint row = 0;
#line 42 "../src/number-picker.vala"
					row = 0;
#line 343 "number-picker.c"
					{
						gboolean _tmp5_ = FALSE;
#line 42 "../src/number-picker.vala"
						_tmp5_ = TRUE;
#line 42 "../src/number-picker.vala"
						while (TRUE) {
#line 350 "number-picker.c"
							Block5Data* _data5_;
							gint _tmp7_;
							gint _tmp8_;
							gint _tmp9_;
							gint _tmp10_;
							GtkButton* _tmp11_ = NULL;
							GtkButton* button = NULL;
							GtkButton* _tmp14_;
							GtkButton* _tmp15_;
							GtkButton* _tmp16_;
							GtkLabel* label = NULL;
							gchar* _tmp17_;
							gchar* _tmp18_;
							GtkLabel* _tmp19_;
							GtkLabel* _tmp20_;
							GtkLabel* _tmp21_;
							gint _tmp22_ = 0;
							GtkLabel* _tmp23_;
							gint _tmp24_ = 0;
							GtkLabel* _tmp25_;
							gint _tmp26_ = 0;
							GtkLabel* _tmp27_;
							gint _tmp28_ = 0;
							GtkLabel* _tmp29_;
							GtkButton* _tmp30_;
							GtkLabel* _tmp31_;
							GtkLabel* _tmp32_;
							GtkButton* _tmp38_;
#line 42 "../src/number-picker.vala"
							_data5_ = g_slice_new0 (Block5Data);
#line 42 "../src/number-picker.vala"
							_data5_->_ref_count_ = 1;
#line 42 "../src/number-picker.vala"
							_data5_->self = g_object_ref (self);
#line 42 "../src/number-picker.vala"
							if (!_tmp5_) {
#line 387 "number-picker.c"
								gint _tmp6_;
#line 42 "../src/number-picker.vala"
								_tmp6_ = row;
#line 42 "../src/number-picker.vala"
								row = _tmp6_ + 1;
#line 393 "number-picker.c"
							}
#line 42 "../src/number-picker.vala"
							_tmp5_ = FALSE;
#line 42 "../src/number-picker.vala"
							_tmp7_ = sudoku_board_get_block_rows (*board);
#line 42 "../src/number-picker.vala"
							_tmp8_ = _tmp7_;
#line 42 "../src/number-picker.vala"
							if (!(row < _tmp8_)) {
#line 42 "../src/number-picker.vala"
								block5_data_unref (_data5_);
#line 42 "../src/number-picker.vala"
								_data5_ = NULL;
#line 42 "../src/number-picker.vala"
								break;
#line 409 "number-picker.c"
							}
#line 44 "../src/number-picker.vala"
							_tmp9_ = sudoku_board_get_block_cols (*board);
#line 44 "../src/number-picker.vala"
							_tmp10_ = _tmp9_;
#line 44 "../src/number-picker.vala"
							_data5_->n = (col + ((2 - row) * _tmp10_)) + 1;
#line 46 "../src/number-picker.vala"
							if (earmark) {
#line 419 "number-picker.c"
								GtkToggleButton* _tmp12_;
#line 46 "../src/number-picker.vala"
								_tmp12_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 46 "../src/number-picker.vala"
								g_object_ref_sink (_tmp12_);
#line 46 "../src/number-picker.vala"
								_g_object_unref0 (_tmp11_);
#line 46 "../src/number-picker.vala"
								_tmp11_ = (GtkButton*) _tmp12_;
#line 429 "number-picker.c"
							} else {
								GtkButton* _tmp13_;
#line 46 "../src/number-picker.vala"
								_tmp13_ = (GtkButton*) gtk_button_new ();
#line 46 "../src/number-picker.vala"
								g_object_ref_sink (_tmp13_);
#line 46 "../src/number-picker.vala"
								_g_object_unref0 (_tmp11_);
#line 46 "../src/number-picker.vala"
								_tmp11_ = _tmp13_;
#line 440 "number-picker.c"
							}
#line 46 "../src/number-picker.vala"
							_tmp14_ = _g_object_ref0 (_tmp11_);
#line 46 "../src/number-picker.vala"
							button = _tmp14_;
#line 47 "../src/number-picker.vala"
							_tmp15_ = button;
#line 47 "../src/number-picker.vala"
							gtk_widget_set_focus_on_click ((GtkWidget*) _tmp15_, FALSE);
#line 48 "../src/number-picker.vala"
							_tmp16_ = button;
#line 48 "../src/number-picker.vala"
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp16_, col, row, 1, 1);
#line 50 "../src/number-picker.vala"
							_tmp17_ = g_strdup_printf ("<big>%d</big>", _data5_->n);
#line 50 "../src/number-picker.vala"
							_tmp18_ = _tmp17_;
#line 50 "../src/number-picker.vala"
							_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
#line 50 "../src/number-picker.vala"
							g_object_ref_sink (_tmp19_);
#line 50 "../src/number-picker.vala"
							_tmp20_ = _tmp19_;
#line 50 "../src/number-picker.vala"
							_g_free0 (_tmp18_);
#line 50 "../src/number-picker.vala"
							label = _tmp20_;
#line 51 "../src/number-picker.vala"
							_tmp21_ = label;
#line 51 "../src/number-picker.vala"
							gtk_label_set_use_markup (_tmp21_, TRUE);
#line 52 "../src/number-picker.vala"
							if (earmark) {
#line 52 "../src/number-picker.vala"
								_tmp22_ = 0;
#line 476 "number-picker.c"
							} else {
#line 52 "../src/number-picker.vala"
								_tmp22_ = 8;
#line 480 "number-picker.c"
							}
#line 52 "../src/number-picker.vala"
							_tmp23_ = label;
#line 52 "../src/number-picker.vala"
							gtk_widget_set_margin_start ((GtkWidget*) _tmp23_, _tmp22_);
#line 53 "../src/number-picker.vala"
							if (earmark) {
#line 53 "../src/number-picker.vala"
								_tmp24_ = 16;
#line 490 "number-picker.c"
							} else {
#line 53 "../src/number-picker.vala"
								_tmp24_ = 8;
#line 494 "number-picker.c"
							}
#line 53 "../src/number-picker.vala"
							_tmp25_ = label;
#line 53 "../src/number-picker.vala"
							gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, _tmp24_);
#line 54 "../src/number-picker.vala"
							if (earmark) {
#line 54 "../src/number-picker.vala"
								_tmp26_ = 0;
#line 504 "number-picker.c"
							} else {
#line 54 "../src/number-picker.vala"
								_tmp26_ = 4;
#line 508 "number-picker.c"
							}
#line 54 "../src/number-picker.vala"
							_tmp27_ = label;
#line 54 "../src/number-picker.vala"
							gtk_widget_set_margin_top ((GtkWidget*) _tmp27_, _tmp26_);
#line 55 "../src/number-picker.vala"
							if (earmark) {
#line 55 "../src/number-picker.vala"
								_tmp28_ = 8;
#line 518 "number-picker.c"
							} else {
#line 55 "../src/number-picker.vala"
								_tmp28_ = 4;
#line 522 "number-picker.c"
							}
#line 55 "../src/number-picker.vala"
							_tmp29_ = label;
#line 55 "../src/number-picker.vala"
							gtk_widget_set_margin_bottom ((GtkWidget*) _tmp29_, _tmp28_);
#line 56 "../src/number-picker.vala"
							_tmp30_ = button;
#line 56 "../src/number-picker.vala"
							_tmp31_ = label;
#line 56 "../src/number-picker.vala"
							gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 57 "../src/number-picker.vala"
							_tmp32_ = label;
#line 57 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp32_);
#line 59 "../src/number-picker.vala"
							if (!earmark) {
#line 540 "number-picker.c"
								GtkButton* _tmp33_;
#line 60 "../src/number-picker.vala"
								_tmp33_ = button;
#line 60 "../src/number-picker.vala"
								g_signal_connect_data (_tmp33_, "clicked", (GCallback) __________lambda4__gtk_button_clicked, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 546 "number-picker.c"
							} else {
								Block6Data* _data6_;
								GtkButton* _tmp34_;
								GtkToggleButton* _tmp35_;
								GtkToggleButton* _tmp36_;
#line 59 "../src/number-picker.vala"
								_data6_ = g_slice_new0 (Block6Data);
#line 59 "../src/number-picker.vala"
								_data6_->_ref_count_ = 1;
#line 59 "../src/number-picker.vala"
								_data6_->_data5_ = block5_data_ref (_data5_);
#line 65 "../src/number-picker.vala"
								_tmp34_ = button;
#line 65 "../src/number-picker.vala"
								_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 65 "../src/number-picker.vala"
								_data6_->toggle_button = _tmp35_;
#line 66 "../src/number-picker.vala"
								_tmp36_ = _data6_->toggle_button;
#line 66 "../src/number-picker.vala"
								g_signal_connect_data (_tmp36_, "toggled", (GCallback) __________lambda5__gtk_toggle_button_toggled, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 59 "../src/number-picker.vala"
								block6_data_unref (_data6_);
#line 59 "../src/number-picker.vala"
								_data6_ = NULL;
#line 572 "number-picker.c"
							}
#line 72 "../src/number-picker.vala"
							if (_data5_->n == 5) {
#line 576 "number-picker.c"
								GtkButton* _tmp37_;
#line 73 "../src/number-picker.vala"
								_tmp37_ = button;
#line 73 "../src/number-picker.vala"
								gtk_widget_grab_focus ((GtkWidget*) _tmp37_);
#line 582 "number-picker.c"
							}
#line 75 "../src/number-picker.vala"
							_tmp38_ = button;
#line 75 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp38_);
#line 42 "../src/number-picker.vala"
							_g_object_unref0 (label);
#line 42 "../src/number-picker.vala"
							_g_object_unref0 (button);
#line 42 "../src/number-picker.vala"
							_g_object_unref0 (_tmp11_);
#line 42 "../src/number-picker.vala"
							block5_data_unref (_data5_);
#line 42 "../src/number-picker.vala"
							_data5_ = NULL;
#line 598 "number-picker.c"
						}
					}
				}
			}
		}
	}
#line 79 "../src/number-picker.vala"
	if (!earmark) {
#line 607 "number-picker.c"
		GtkButton* _tmp39_;
		GtkButton* _tmp40_;
		GtkButton* _tmp41_;
		GtkLabel* label = NULL;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GtkLabel* _tmp44_;
		GtkLabel* _tmp45_;
		GtkLabel* _tmp46_;
		GtkButton* _tmp47_;
		GtkLabel* _tmp48_;
		GtkLabel* _tmp49_;
		GtkButton* _tmp50_;
#line 81 "../src/number-picker.vala"
		_tmp39_ = (GtkButton*) gtk_button_new ();
#line 81 "../src/number-picker.vala"
		g_object_ref_sink (_tmp39_);
#line 81 "../src/number-picker.vala"
		_g_object_unref0 (self->priv->clear_button);
#line 81 "../src/number-picker.vala"
		self->priv->clear_button = _tmp39_;
#line 82 "../src/number-picker.vala"
		_tmp40_ = self->priv->clear_button;
#line 82 "../src/number-picker.vala"
		gtk_widget_set_focus_on_click ((GtkWidget*) _tmp40_, FALSE);
#line 83 "../src/number-picker.vala"
		_tmp41_ = self->priv->clear_button;
#line 83 "../src/number-picker.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp41_, 0, 4, 3, 1);
#line 85 "../src/number-picker.vala"
		_tmp42_ = g_strdup_printf ("<big>%s</big>", _ ("Clear"));
#line 85 "../src/number-picker.vala"
		_tmp43_ = _tmp42_;
#line 85 "../src/number-picker.vala"
		_tmp44_ = (GtkLabel*) gtk_label_new (_tmp43_);
#line 85 "../src/number-picker.vala"
		g_object_ref_sink (_tmp44_);
#line 85 "../src/number-picker.vala"
		_tmp45_ = _tmp44_;
#line 85 "../src/number-picker.vala"
		_g_free0 (_tmp43_);
#line 85 "../src/number-picker.vala"
		label = _tmp45_;
#line 86 "../src/number-picker.vala"
		_tmp46_ = label;
#line 86 "../src/number-picker.vala"
		gtk_label_set_use_markup (_tmp46_, TRUE);
#line 87 "../src/number-picker.vala"
		_tmp47_ = self->priv->clear_button;
#line 87 "../src/number-picker.vala"
		_tmp48_ = label;
#line 87 "../src/number-picker.vala"
		gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 88 "../src/number-picker.vala"
		_tmp49_ = label;
#line 88 "../src/number-picker.vala"
		gtk_widget_show ((GtkWidget*) _tmp49_);
#line 90 "../src/number-picker.vala"
		_tmp50_ = self->priv->clear_button;
#line 90 "../src/number-picker.vala"
		g_signal_connect_object (_tmp50_, "clicked", (GCallback) ____lambda6__gtk_button_clicked, self, 0);
#line 79 "../src/number-picker.vala"
		_g_object_unref0 (label);
#line 671 "number-picker.c"
	}
#line 95 "../src/number-picker.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 96 "../src/number-picker.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 97 "../src/number-picker.vala"
	g_object_set ((GtkWidget*) self, "margin", 2, NULL);
#line 98 "../src/number-picker.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 3);
#line 99 "../src/number-picker.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 3);
#line 100 "../src/number-picker.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 35 "../src/number-picker.vala"
	return self;
#line 687 "number-picker.c"
}

NumberPicker*
number_picker_new (SudokuBoard** board,
                   gboolean earmark)
{
#line 35 "../src/number-picker.vala"
	return number_picker_construct (TYPE_NUMBER_PICKER, board, earmark);
#line 696 "number-picker.c"
}

void
number_picker_set_clear_button_visibility (NumberPicker* self,
                                           gboolean visible)
{
#line 103 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/number-picker.vala"
	if (visible) {
#line 707 "number-picker.c"
		GtkButton* _tmp0_;
#line 106 "../src/number-picker.vala"
		_tmp0_ = self->priv->clear_button;
#line 106 "../src/number-picker.vala"
		gtk_widget_show ((GtkWidget*) _tmp0_);
#line 713 "number-picker.c"
	} else {
		GtkButton* _tmp1_;
#line 108 "../src/number-picker.vala"
		_tmp1_ = self->priv->clear_button;
#line 108 "../src/number-picker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 720 "number-picker.c"
	}
}

void
number_picker_set_earmarks (NumberPicker* self,
                            gint row,
                            gint col)
{
#line 111 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 731 "number-picker.c"
	{
		gint i = 0;
#line 113 "../src/number-picker.vala"
		i = 0;
#line 736 "number-picker.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "../src/number-picker.vala"
			_tmp0_ = TRUE;
#line 113 "../src/number-picker.vala"
			while (TRUE) {
#line 743 "number-picker.c"
				SudokuBoard* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				SudokuBoard* _tmp5_;
#line 113 "../src/number-picker.vala"
				if (!_tmp0_) {
#line 750 "number-picker.c"
					gint _tmp1_;
#line 113 "../src/number-picker.vala"
					_tmp1_ = i;
#line 113 "../src/number-picker.vala"
					i = _tmp1_ + 1;
#line 756 "number-picker.c"
				}
#line 113 "../src/number-picker.vala"
				_tmp0_ = FALSE;
#line 113 "../src/number-picker.vala"
				_tmp2_ = self->priv->board;
#line 113 "../src/number-picker.vala"
				_tmp3_ = sudoku_board_get_max_val (_tmp2_);
#line 113 "../src/number-picker.vala"
				_tmp4_ = _tmp3_;
#line 113 "../src/number-picker.vala"
				if (!(i < _tmp4_)) {
#line 113 "../src/number-picker.vala"
					break;
#line 770 "number-picker.c"
				}
#line 114 "../src/number-picker.vala"
				_tmp5_ = self->priv->board;
#line 114 "../src/number-picker.vala"
				number_picker_set_earmark (self, row, col, i, sudoku_board_is_earmark_enabled (_tmp5_, row, col, i + 1));
#line 776 "number-picker.c"
			}
		}
	}
}

void
number_picker_set_earmark (NumberPicker* self,
                           gint row,
                           gint col,
                           gint index,
                           gboolean state)
{
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
#line 117 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/number-picker.vala"
	_tmp0_ = number_picker_get_button_for (self, index);
#line 119 "../src/number-picker.vala"
	_tmp1_ = _tmp0_;
#line 119 "../src/number-picker.vala"
	gtk_toggle_button_set_active (_tmp1_, state);
#line 119 "../src/number-picker.vala"
	_g_object_unref0 (_tmp1_);
#line 801 "number-picker.c"
}

static GtkToggleButton*
number_picker_get_button_for (NumberPicker* self,
                              gint number)
{
	SudokuBoard* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkWidget* _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkToggleButton* result;
#line 122 "../src/number-picker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../src/number-picker.vala"
	_tmp0_ = self->priv->board;
#line 124 "../src/number-picker.vala"
	_tmp1_ = sudoku_board_get_block_cols (_tmp0_);
#line 124 "../src/number-picker.vala"
	_tmp2_ = _tmp1_;
#line 124 "../src/number-picker.vala"
	_tmp3_ = self->priv->board;
#line 124 "../src/number-picker.vala"
	_tmp4_ = sudoku_board_get_block_rows (_tmp3_);
#line 124 "../src/number-picker.vala"
	_tmp5_ = _tmp4_;
#line 124 "../src/number-picker.vala"
	_tmp6_ = gtk_grid_get_child_at ((GtkGrid*) self, number % _tmp2_, 2 - (number / _tmp5_));
#line 124 "../src/number-picker.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 124 "../src/number-picker.vala"
	result = _tmp7_;
#line 124 "../src/number-picker.vala"
	return result;
#line 839 "number-picker.c"
}

static void
g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/number-picker.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/number-picker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/number-picker.vala"
		data1 = closure->data;
#line 24 "../src/number-picker.vala"
		data2 = param_values->data[0].v_pointer;
#line 864 "number-picker.c"
	} else {
#line 24 "../src/number-picker.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/number-picker.vala"
		data2 = closure->data;
#line 870 "number-picker.c"
	}
#line 24 "../src/number-picker.vala"
	callback = (GMarshalFunc_VOID__INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/number-picker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 876 "number-picker.c"
}

static void
number_picker_class_init (NumberPickerClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/number-picker.vala"
	number_picker_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/number-picker.vala"
	g_type_class_adjust_private_offset (klass, &NumberPicker_private_offset);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->finalize = number_picker_finalize;
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL] = g_signal_new ("number-picked", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL] = g_signal_new ("earmark-state-changed", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 893 "number-picker.c"
}

static void
number_picker_instance_init (NumberPicker * self,
                             gpointer klass)
{
#line 24 "../src/number-picker.vala"
	self->priv = number_picker_get_instance_private (self);
#line 902 "number-picker.c"
}

static void
number_picker_finalize (GObject * obj)
{
	NumberPicker * self;
#line 24 "../src/number-picker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER_PICKER, NumberPicker);
#line 26 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 31 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (number_picker_parent_class)->finalize (obj);
#line 917 "number-picker.c"
}

static GType
number_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NumberPicker), 0, (GInstanceInitFunc) number_picker_instance_init, NULL };
	GType number_picker_type_id;
	number_picker_type_id = g_type_register_static (gtk_grid_get_type (), "NumberPicker", &g_define_type_info, 0);
	NumberPicker_private_offset = g_type_add_instance_private (number_picker_type_id, sizeof (NumberPickerPrivate));
	return number_picker_type_id;
}

GType
number_picker_get_type (void)
{
	static volatile gsize number_picker_type_id__once = 0;
	if (g_once_init_enter (&number_picker_type_id__once)) {
		GType number_picker_type_id;
		number_picker_type_id = number_picker_get_type_once ();
		g_once_init_leave (&number_picker_type_id__once, number_picker_type_id);
	}
	return number_picker_type_id__once;
}

