/* print-dialog.c generated by valac 0.56.4, the Vala compiler
 * generated from print-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>

#define PRINT_DIALOG_DIFFICULTY_KEY_NAME "print-multiple-sudoku-difficulty"
#define PRINT_DIALOG_MAX_PUZZLES_PER_PAGE 15
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PRINT_DIALOG (print_dialog_get_type ())
#define PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PRINT_DIALOG, PrintDialog))
#define PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PRINT_DIALOG, PrintDialogClass))
#define IS_PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PRINT_DIALOG))
#define IS_PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PRINT_DIALOG))
#define PRINT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PRINT_DIALOG, PrintDialogClass))

typedef struct _PrintDialog PrintDialog;
typedef struct _PrintDialogClass PrintDialogClass;
typedef struct _PrintDialogPrivate PrintDialogPrivate;
enum  {
	PRINT_DIALOG_0_PROPERTY,
	PRINT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* print_dialog_properties[PRINT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;

#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PrintDialog {
	GtkDialog parent_instance;
	PrintDialogPrivate * priv;
};

struct _PrintDialogClass {
	GtkDialogClass parent_class;
};

struct _PrintDialogPrivate {
	SudokuSaver* saver;
	GSettings* settings;
	GtkButton* print_button;
	GtkGrid* print_grid;
	GtkSpinButton* n_sudokus_button;
	GtkSpinButton* n_sudokus_per_page_button;
	GtkRadioButton* easy_radio_button;
	GtkRadioButton* medium_radio_button;
	GtkRadioButton* hard_radio_button;
	GtkRadioButton* very_hard_radio_button;
	GtkRevealer* revealer;
	GtkSpinner* spinner;
	GCancellable* cancellable;
};

struct _Block7Data {
	int _ref_count_;
	PrintDialog* self;
	GtkAdjustment* total;
	GtkAdjustment* per_page;
};

struct _Block8Data {
	int _ref_count_;
	PrintDialog* self;
	gint nsudokus_per_page;
};

static gint PrintDialog_private_offset;
static gpointer print_dialog_parent_class = NULL;

VALA_EXTERN GType print_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrintDialog, g_object_unref)
VALA_EXTERN PrintDialog* print_dialog_new (SudokuSaver* saver,
                               GtkWindow* window);
VALA_EXTERN PrintDialog* print_dialog_construct (GType object_type,
                                     SudokuSaver* saver,
                                     GtkWindow* window);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda25_ (PrintDialog* self,
                  gint response_id);
static void ___lambda25__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda26_ (Block7Data* _data7_);
static void ___lambda26__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
static void __lambda27_ (Block7Data* _data7_);
static void ___lambda27__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
VALA_EXTERN gboolean print_dialog_start_spinner_cb (PrintDialog* self);
static void print_dialog_real_response (GtkDialog* base,
                                 gint response);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda24_ (Block8Data* _data8_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN GType sudoku_printer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPrinter, g_object_unref)
VALA_EXTERN SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   gint sudokus_per_page,
                                   GtkWindow* window);
VALA_EXTERN SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         gint sudokus_per_page,
                                         GtkWindow* window);
VALA_EXTERN GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
static void ___lambda24__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void print_dialog_finalize (GObject * obj);
static GType print_dialog_get_type_once (void);

static inline gpointer
print_dialog_get_instance_private (PrintDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PrintDialog_private_offset);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 47 "../src/print-dialog.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 47 "../src/print-dialog.vala"
	return _data7_;
#line 177 "print-dialog.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 47 "../src/print-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 187 "print-dialog.c"
		PrintDialog* self;
#line 47 "../src/print-dialog.vala"
		self = _data7_->self;
#line 47 "../src/print-dialog.vala"
		_g_object_unref0 (_data7_->per_page);
#line 47 "../src/print-dialog.vala"
		_g_object_unref0 (_data7_->total);
#line 47 "../src/print-dialog.vala"
		_g_object_unref0 (self);
#line 47 "../src/print-dialog.vala"
		g_slice_free (Block7Data, _data7_);
#line 199 "print-dialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/print-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 208 "print-dialog.c"
}

static void
__lambda25_ (PrintDialog* self,
             gint response_id)
{
	gboolean _tmp0_ = FALSE;
#line 55 "../src/print-dialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_CANCEL)) {
#line 55 "../src/print-dialog.vala"
		_tmp0_ = TRUE;
#line 220 "print-dialog.c"
	} else {
#line 55 "../src/print-dialog.vala"
		_tmp0_ = response_id == ((gint) GTK_RESPONSE_DELETE_EVENT);
#line 224 "print-dialog.c"
	}
#line 55 "../src/print-dialog.vala"
	if (_tmp0_) {
#line 228 "print-dialog.c"
		GCancellable* _tmp1_;
#line 56 "../src/print-dialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 56 "../src/print-dialog.vala"
		g_cancellable_cancel (_tmp1_);
#line 234 "print-dialog.c"
	}
}

static void
___lambda25__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 54 "../src/print-dialog.vala"
	__lambda25_ ((PrintDialog*) self, response_id);
#line 245 "print-dialog.c"
}

static void
__lambda26_ (Block7Data* _data7_)
{
	PrintDialog* self;
	gint total_value = 0;
	GSettings* _tmp0_;
	gint max_per_page = 0;
	gint per_page_value = 0;
#line 90 "../src/print-dialog.vala"
	self = _data7_->self;
#line 91 "../src/print-dialog.vala"
	total_value = (gint) gtk_adjustment_get_value (_data7_->total);
#line 92 "../src/print-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 92 "../src/print-dialog.vala"
	g_settings_set_int (_tmp0_, "print-multiple-sudokus-to-print", total_value);
#line 94 "../src/print-dialog.vala"
	max_per_page = MIN (PRINT_DIALOG_MAX_PUZZLES_PER_PAGE, total_value);
#line 95 "../src/print-dialog.vala"
	per_page_value = (gint) gtk_adjustment_get_value (_data7_->per_page);
#line 96 "../src/print-dialog.vala"
	per_page_value = MIN (per_page_value, max_per_page);
#line 97 "../src/print-dialog.vala"
	gtk_adjustment_set_upper (_data7_->per_page, (gdouble) max_per_page);
#line 98 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data7_->per_page, (gdouble) per_page_value);
#line 274 "print-dialog.c"
}

static void
___lambda26__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 90 "../src/print-dialog.vala"
	__lambda26_ (self);
#line 283 "print-dialog.c"
}

static void
__lambda27_ (Block7Data* _data7_)
{
	PrintDialog* self;
	gint per_page_value = 0;
	GSettings* _tmp0_;
#line 100 "../src/print-dialog.vala"
	self = _data7_->self;
#line 101 "../src/print-dialog.vala"
	per_page_value = (gint) gtk_adjustment_get_value (_data7_->per_page);
#line 102 "../src/print-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 102 "../src/print-dialog.vala"
	g_settings_set_int (_tmp0_, "print-multiple-sudokus-to-print-per-page", per_page_value);
#line 300 "print-dialog.c"
}

static void
___lambda27__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 100 "../src/print-dialog.vala"
	__lambda27_ (self);
#line 309 "print-dialog.c"
}

PrintDialog*
print_dialog_construct (GType object_type,
                        SudokuSaver* saver,
                        GtkWindow* window)
{
	PrintDialog * self = NULL;
	Block7Data* _data7_;
	SudokuSaver* _tmp0_;
	GSettings* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkRevealer* _tmp3_;
	GtkRevealer* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkHeaderBar* _tmp7_;
	GtkRevealer* _tmp8_;
	DifficultyCategory saved_difficulty = 0;
	GSettings* _tmp9_;
	gint initial_total_value = 0;
	GSettings* _tmp14_;
	gint initial_per_page_value = 0;
	GSettings* _tmp15_;
	GtkSpinButton* _tmp16_;
	GtkAdjustment* _tmp17_;
	GtkAdjustment* _tmp18_;
	GtkSpinButton* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkAdjustment* _tmp21_;
	gint initial_max_per_page = 0;
#line 47 "../src/print-dialog.vala"
	g_return_val_if_fail (saver != NULL, NULL);
#line 47 "../src/print-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 47 "../src/print-dialog.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 47 "../src/print-dialog.vala"
	_data7_->_ref_count_ = 1;
#line 49 "../src/print-dialog.vala"
	self = (PrintDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 49 "../src/print-dialog.vala"
	_data7_->self = g_object_ref (self);
#line 51 "../src/print-dialog.vala"
	_tmp0_ = _g_object_ref0 (saver);
#line 51 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 51 "../src/print-dialog.vala"
	self->priv->saver = _tmp0_;
#line 52 "../src/print-dialog.vala"
	_tmp1_ = g_settings_new ("org.gnome.Sudoku");
#line 52 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 52 "../src/print-dialog.vala"
	self->priv->settings = _tmp1_;
#line 54 "../src/print-dialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda25__gtk_dialog_response, self, 0);
#line 59 "../src/print-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 61 "../src/print-dialog.vala"
	_tmp2_ = (GtkSpinner*) gtk_spinner_new ();
#line 61 "../src/print-dialog.vala"
	g_object_ref_sink (_tmp2_);
#line 61 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 61 "../src/print-dialog.vala"
	self->priv->spinner = _tmp2_;
#line 62 "../src/print-dialog.vala"
	_tmp3_ = (GtkRevealer*) gtk_revealer_new ();
#line 62 "../src/print-dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 62 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->revealer);
#line 62 "../src/print-dialog.vala"
	self->priv->revealer = _tmp3_;
#line 63 "../src/print-dialog.vala"
	_tmp4_ = self->priv->revealer;
#line 63 "../src/print-dialog.vala"
	_tmp5_ = self->priv->spinner;
#line 63 "../src/print-dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 64 "../src/print-dialog.vala"
	_tmp6_ = self->priv->revealer;
#line 64 "../src/print-dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 65 "../src/print-dialog.vala"
	_tmp7_ = gtk_dialog_get_header_bar ((GtkDialog*) self);
#line 65 "../src/print-dialog.vala"
	_tmp8_ = self->priv->revealer;
#line 65 "../src/print-dialog.vala"
	gtk_header_bar_pack_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_header_bar_get_type (), GtkHeaderBar), (GtkWidget*) _tmp8_);
#line 67 "../src/print-dialog.vala"
	_tmp9_ = self->priv->settings;
#line 67 "../src/print-dialog.vala"
	saved_difficulty = (DifficultyCategory) g_settings_get_enum (_tmp9_, PRINT_DIALOG_DIFFICULTY_KEY_NAME);
#line 68 "../src/print-dialog.vala"
	if (saved_difficulty == DIFFICULTY_CATEGORY_EASY) {
#line 407 "print-dialog.c"
		GtkRadioButton* _tmp10_;
#line 69 "../src/print-dialog.vala"
		_tmp10_ = self->priv->easy_radio_button;
#line 69 "../src/print-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, TRUE);
#line 413 "print-dialog.c"
	} else {
#line 70 "../src/print-dialog.vala"
		if (saved_difficulty == DIFFICULTY_CATEGORY_MEDIUM) {
#line 417 "print-dialog.c"
			GtkRadioButton* _tmp11_;
#line 71 "../src/print-dialog.vala"
			_tmp11_ = self->priv->medium_radio_button;
#line 71 "../src/print-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp11_, TRUE);
#line 423 "print-dialog.c"
		} else {
#line 72 "../src/print-dialog.vala"
			if (saved_difficulty == DIFFICULTY_CATEGORY_HARD) {
#line 427 "print-dialog.c"
				GtkRadioButton* _tmp12_;
#line 73 "../src/print-dialog.vala"
				_tmp12_ = self->priv->hard_radio_button;
#line 73 "../src/print-dialog.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp12_, TRUE);
#line 433 "print-dialog.c"
			} else {
#line 74 "../src/print-dialog.vala"
				if (saved_difficulty == DIFFICULTY_CATEGORY_VERY_HARD) {
#line 437 "print-dialog.c"
					GtkRadioButton* _tmp13_;
#line 75 "../src/print-dialog.vala"
					_tmp13_ = self->priv->very_hard_radio_button;
#line 75 "../src/print-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp13_, TRUE);
#line 443 "print-dialog.c"
				} else {
#line 77 "../src/print-dialog.vala"
					g_assert_not_reached ();
#line 447 "print-dialog.c"
				}
			}
		}
	}
#line 79 "../src/print-dialog.vala"
	_tmp14_ = self->priv->settings;
#line 79 "../src/print-dialog.vala"
	initial_total_value = g_settings_get_int (_tmp14_, "print-multiple-sudokus-to-print");
#line 80 "../src/print-dialog.vala"
	_tmp15_ = self->priv->settings;
#line 80 "../src/print-dialog.vala"
	initial_per_page_value = g_settings_get_int (_tmp15_, "print-multiple-sudokus-to-print-per-page");
#line 82 "../src/print-dialog.vala"
	_tmp16_ = self->priv->n_sudokus_button;
#line 82 "../src/print-dialog.vala"
	_tmp17_ = gtk_spin_button_get_adjustment (_tmp16_);
#line 82 "../src/print-dialog.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 82 "../src/print-dialog.vala"
	_data7_->total = _tmp18_;
#line 83 "../src/print-dialog.vala"
	_tmp19_ = self->priv->n_sudokus_per_page_button;
#line 83 "../src/print-dialog.vala"
	_tmp20_ = gtk_spin_button_get_adjustment (_tmp19_);
#line 83 "../src/print-dialog.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 83 "../src/print-dialog.vala"
	_data7_->per_page = _tmp21_;
#line 85 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data7_->total, (gdouble) initial_total_value);
#line 86 "../src/print-dialog.vala"
	initial_max_per_page = MIN (PRINT_DIALOG_MAX_PUZZLES_PER_PAGE, initial_total_value);
#line 87 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data7_->per_page, (gdouble) MIN (initial_max_per_page, initial_per_page_value));
#line 88 "../src/print-dialog.vala"
	gtk_adjustment_set_upper (_data7_->per_page, (gdouble) initial_max_per_page);
#line 90 "../src/print-dialog.vala"
	g_signal_connect_data (_data7_->total, "value-changed", (GCallback) ___lambda26__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 100 "../src/print-dialog.vala"
	g_signal_connect_data (_data7_->per_page, "value-changed", (GCallback) ___lambda27__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 47 "../src/print-dialog.vala"
	block7_data_unref (_data7_);
#line 47 "../src/print-dialog.vala"
	_data7_ = NULL;
#line 47 "../src/print-dialog.vala"
	return self;
#line 494 "print-dialog.c"
}

PrintDialog*
print_dialog_new (SudokuSaver* saver,
                  GtkWindow* window)
{
#line 47 "../src/print-dialog.vala"
	return print_dialog_construct (TYPE_PRINT_DIALOG, saver, window);
#line 503 "print-dialog.c"
}

gboolean
print_dialog_start_spinner_cb (PrintDialog* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkRevealer* _tmp3_;
	gboolean result;
#line 106 "../src/print-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 108 "../src/print-dialog.vala"
	_tmp0_ = self->priv->revealer;
#line 108 "../src/print-dialog.vala"
	gtk_revealer_set_transition_type (_tmp0_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 109 "../src/print-dialog.vala"
	_tmp1_ = self->priv->revealer;
#line 109 "../src/print-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 110 "../src/print-dialog.vala"
	_tmp2_ = self->priv->spinner;
#line 110 "../src/print-dialog.vala"
	gtk_spinner_start (_tmp2_);
#line 111 "../src/print-dialog.vala"
	_tmp3_ = self->priv->revealer;
#line 111 "../src/print-dialog.vala"
	gtk_revealer_set_reveal_child (_tmp3_, TRUE);
#line 112 "../src/print-dialog.vala"
	result = G_SOURCE_REMOVE;
#line 112 "../src/print-dialog.vala"
	return result;
#line 536 "print-dialog.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 115 "../src/print-dialog.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 115 "../src/print-dialog.vala"
	return _data8_;
#line 546 "print-dialog.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 115 "../src/print-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 556 "print-dialog.c"
		PrintDialog* self;
#line 115 "../src/print-dialog.vala"
		self = _data8_->self;
#line 115 "../src/print-dialog.vala"
		_g_object_unref0 (self);
#line 115 "../src/print-dialog.vala"
		g_slice_free (Block8Data, _data8_);
#line 564 "print-dialog.c"
	}
}

static void
__lambda24_ (Block8Data* _data8_,
             GObject* obj,
             GAsyncResult* res)
{
	PrintDialog* self;
	GError* _inner_error0_ = NULL;
#line 146 "../src/print-dialog.vala"
	self = _data8_->self;
#line 146 "../src/print-dialog.vala"
	g_return_if_fail (res != NULL);
#line 579 "print-dialog.c"
	{
		GeeList* boards = NULL;
		GeeList* _tmp0_;
		GtkSpinner* _tmp1_;
		GtkRevealer* _tmp2_;
		SudokuPrinter* printer = NULL;
		SudokuPrinter* _tmp3_;
		SudokuPrinter* _tmp4_;
#line 149 "../src/print-dialog.vala"
		_tmp0_ = sudoku_generator_generate_boards_finish (res, &_inner_error0_);
#line 149 "../src/print-dialog.vala"
		boards = _tmp0_;
#line 149 "../src/print-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 596 "print-dialog.c"
				goto __catch0_g_thread_error;
			}
#line 149 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 601 "print-dialog.c"
				goto __catch0_g_io_error;
			}
#line 149 "../src/print-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/print-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../src/print-dialog.vala"
			return;
#line 610 "print-dialog.c"
		}
#line 151 "../src/print-dialog.vala"
		_tmp1_ = self->priv->spinner;
#line 151 "../src/print-dialog.vala"
		gtk_spinner_stop (_tmp1_);
#line 152 "../src/print-dialog.vala"
		_tmp2_ = self->priv->revealer;
#line 152 "../src/print-dialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 154 "../src/print-dialog.vala"
		_tmp3_ = sudoku_printer_new (boards, _data8_->nsudokus_per_page, (GtkWindow*) self);
#line 154 "../src/print-dialog.vala"
		printer = _tmp3_;
#line 155 "../src/print-dialog.vala"
		_tmp4_ = printer;
#line 155 "../src/print-dialog.vala"
		if (sudoku_printer_print_sudoku (_tmp4_) == GTK_PRINT_OPERATION_RESULT_APPLY) {
#line 628 "print-dialog.c"
			{
				GeeList* _board_list = NULL;
				gint _board_size = 0;
				GeeList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _board_index = 0;
#line 157 "../src/print-dialog.vala"
				_board_list = boards;
#line 157 "../src/print-dialog.vala"
				_tmp5_ = _board_list;
#line 157 "../src/print-dialog.vala"
				_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 157 "../src/print-dialog.vala"
				_tmp7_ = _tmp6_;
#line 157 "../src/print-dialog.vala"
				_board_size = _tmp7_;
#line 157 "../src/print-dialog.vala"
				_board_index = -1;
#line 157 "../src/print-dialog.vala"
				while (TRUE) {
#line 650 "print-dialog.c"
					gint _tmp8_;
					gint _tmp9_;
					SudokuBoard* board = NULL;
					GeeList* _tmp10_;
					gpointer _tmp11_;
					SudokuSaver* _tmp12_;
					SudokuBoard* _tmp13_;
					SudokuGame* _tmp14_;
					SudokuGame* _tmp15_;
#line 157 "../src/print-dialog.vala"
					_board_index = _board_index + 1;
#line 157 "../src/print-dialog.vala"
					_tmp8_ = _board_index;
#line 157 "../src/print-dialog.vala"
					_tmp9_ = _board_size;
#line 157 "../src/print-dialog.vala"
					if (!(_tmp8_ < _tmp9_)) {
#line 157 "../src/print-dialog.vala"
						break;
#line 670 "print-dialog.c"
					}
#line 157 "../src/print-dialog.vala"
					_tmp10_ = _board_list;
#line 157 "../src/print-dialog.vala"
					_tmp11_ = gee_list_get (_tmp10_, _board_index);
#line 157 "../src/print-dialog.vala"
					board = (SudokuBoard*) _tmp11_;
#line 158 "../src/print-dialog.vala"
					_tmp12_ = self->priv->saver;
#line 158 "../src/print-dialog.vala"
					_tmp13_ = board;
#line 158 "../src/print-dialog.vala"
					_tmp14_ = sudoku_game_new (_tmp13_);
#line 158 "../src/print-dialog.vala"
					_tmp15_ = _tmp14_;
#line 158 "../src/print-dialog.vala"
					sudoku_saver_add_game_to_finished (_tmp12_, _tmp15_, FALSE);
#line 158 "../src/print-dialog.vala"
					_g_object_unref0 (_tmp15_);
#line 157 "../src/print-dialog.vala"
					_g_object_unref0 (board);
#line 692 "print-dialog.c"
				}
			}
		}
#line 147 "../src/print-dialog.vala"
		_g_object_unref0 (printer);
#line 147 "../src/print-dialog.vala"
		_g_object_unref0 (boards);
#line 700 "print-dialog.c"
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError* e = NULL;
		const gchar* _tmp16_;
#line 147 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 147 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 163 "../src/print-dialog.vala"
		_tmp16_ = e->message;
#line 163 "../src/print-dialog.vala"
		g_error ("print-dialog.vala:163: Thread error: %s\n", _tmp16_);
#line 147 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 717 "print-dialog.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
#line 147 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 147 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 167 "../src/print-dialog.vala"
		_tmp17_ = e;
#line 167 "../src/print-dialog.vala"
		if (!g_error_matches (_tmp17_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 732 "print-dialog.c"
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 168 "../src/print-dialog.vala"
			_tmp18_ = e;
#line 168 "../src/print-dialog.vala"
			_tmp19_ = _tmp18_->message;
#line 168 "../src/print-dialog.vala"
			g_warning ("print-dialog.vala:168: Error: %s\n", _tmp19_);
#line 741 "print-dialog.c"
		}
#line 147 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 745 "print-dialog.c"
	}
	__finally0:
#line 147 "../src/print-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/print-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/print-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/print-dialog.vala"
		return;
#line 756 "print-dialog.c"
	}
#line 171 "../src/print-dialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 760 "print-dialog.c"
}

static void
___lambda24__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 146 "../src/print-dialog.vala"
	__lambda24_ (self, source_object, res);
#line 146 "../src/print-dialog.vala"
	block8_data_unref (self);
#line 772 "print-dialog.c"
}

static void
print_dialog_real_response (GtkDialog* base,
                            gint response)
{
	PrintDialog * self;
	Block8Data* _data8_;
	gint nsudokus = 0;
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkSpinButton* _tmp2_;
	GtkAdjustment* _tmp3_;
	DifficultyCategory level = 0;
	GtkRadioButton* _tmp4_;
	GSettings* _tmp8_;
	GtkButton* _tmp9_;
	GtkGrid* _tmp10_;
	GCancellable* _tmp11_;
	GCancellable* _tmp12_;
#line 115 "../src/print-dialog.vala"
	self = (PrintDialog*) base;
#line 115 "../src/print-dialog.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 115 "../src/print-dialog.vala"
	_data8_->_ref_count_ = 1;
#line 115 "../src/print-dialog.vala"
	_data8_->self = g_object_ref (self);
#line 117 "../src/print-dialog.vala"
	if (response != ((gint) GTK_RESPONSE_OK)) {
#line 119 "../src/print-dialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 120 "../src/print-dialog.vala"
		block8_data_unref (_data8_);
#line 120 "../src/print-dialog.vala"
		_data8_ = NULL;
#line 120 "../src/print-dialog.vala"
		return;
#line 811 "print-dialog.c"
	}
#line 123 "../src/print-dialog.vala"
	_tmp0_ = self->priv->n_sudokus_button;
#line 123 "../src/print-dialog.vala"
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
#line 123 "../src/print-dialog.vala"
	nsudokus = (gint) gtk_adjustment_get_value (_tmp1_);
#line 124 "../src/print-dialog.vala"
	_tmp2_ = self->priv->n_sudokus_per_page_button;
#line 124 "../src/print-dialog.vala"
	_tmp3_ = gtk_spin_button_get_adjustment (_tmp2_);
#line 124 "../src/print-dialog.vala"
	_data8_->nsudokus_per_page = (gint) gtk_adjustment_get_value (_tmp3_);
#line 127 "../src/print-dialog.vala"
	_tmp4_ = self->priv->easy_radio_button;
#line 127 "../src/print-dialog.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_)) {
#line 128 "../src/print-dialog.vala"
		level = DIFFICULTY_CATEGORY_EASY;
#line 831 "print-dialog.c"
	} else {
		GtkRadioButton* _tmp5_;
#line 129 "../src/print-dialog.vala"
		_tmp5_ = self->priv->medium_radio_button;
#line 129 "../src/print-dialog.vala"
		if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_)) {
#line 130 "../src/print-dialog.vala"
			level = DIFFICULTY_CATEGORY_MEDIUM;
#line 840 "print-dialog.c"
		} else {
			GtkRadioButton* _tmp6_;
#line 131 "../src/print-dialog.vala"
			_tmp6_ = self->priv->hard_radio_button;
#line 131 "../src/print-dialog.vala"
			if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_)) {
#line 132 "../src/print-dialog.vala"
				level = DIFFICULTY_CATEGORY_HARD;
#line 849 "print-dialog.c"
			} else {
				GtkRadioButton* _tmp7_;
#line 133 "../src/print-dialog.vala"
				_tmp7_ = self->priv->very_hard_radio_button;
#line 133 "../src/print-dialog.vala"
				if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp7_)) {
#line 134 "../src/print-dialog.vala"
					level = DIFFICULTY_CATEGORY_VERY_HARD;
#line 858 "print-dialog.c"
				} else {
#line 136 "../src/print-dialog.vala"
					g_assert_not_reached ();
#line 862 "print-dialog.c"
				}
			}
		}
	}
#line 138 "../src/print-dialog.vala"
	_tmp8_ = self->priv->settings;
#line 138 "../src/print-dialog.vala"
	g_settings_set_enum (_tmp8_, PRINT_DIALOG_DIFFICULTY_KEY_NAME, (gint) level);
#line 140 "../src/print-dialog.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 3, (GSourceFunc) print_dialog_start_spinner_cb, g_object_ref (self), g_object_unref);
#line 142 "../src/print-dialog.vala"
	_tmp9_ = self->priv->print_button;
#line 142 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 143 "../src/print-dialog.vala"
	_tmp10_ = self->priv->print_grid;
#line 143 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 145 "../src/print-dialog.vala"
	_tmp11_ = g_cancellable_new ();
#line 145 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 145 "../src/print-dialog.vala"
	self->priv->cancellable = _tmp11_;
#line 146 "../src/print-dialog.vala"
	_tmp12_ = self->priv->cancellable;
#line 146 "../src/print-dialog.vala"
	sudoku_generator_generate_boards_async (nsudokus, level, _tmp12_, ___lambda24__gasync_ready_callback, block8_data_ref (_data8_));
#line 115 "../src/print-dialog.vala"
	block8_data_unref (_data8_);
#line 115 "../src/print-dialog.vala"
	_data8_ = NULL;
#line 895 "print-dialog.c"
}

static void
print_dialog_class_init (PrintDialogClass * klass,
                         gpointer klass_data)
{
#line 25 "../src/print-dialog.vala"
	print_dialog_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/print-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PrintDialog_private_offset);
#line 25 "../src/print-dialog.vala"
	((GtkDialogClass *) klass)->response = (void (*) (GtkDialog*, gint)) print_dialog_real_response;
#line 25 "../src/print-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = print_dialog_finalize;
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/print-dialog.ui");
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "print_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, print_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "print_grid", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, print_grid));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "n_sudokus_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, n_sudokus_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "n_sudokus_per_page_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, n_sudokus_per_page_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, easy_radio_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, medium_radio_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, hard_radio_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, very_hard_radio_button));
#line 928 "print-dialog.c"
}

static void
print_dialog_instance_init (PrintDialog * self,
                            gpointer klass)
{
#line 25 "../src/print-dialog.vala"
	self->priv = print_dialog_get_instance_private (self);
#line 25 "../src/print-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 939 "print-dialog.c"
}

static void
print_dialog_finalize (GObject * obj)
{
	PrintDialog * self;
#line 25 "../src/print-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_DIALOG, PrintDialog);
#line 27 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 28 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 39 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->revealer);
#line 40 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 42 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 25 "../src/print-dialog.vala"
	G_OBJECT_CLASS (print_dialog_parent_class)->finalize (obj);
#line 960 "print-dialog.c"
}

static GType
print_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintDialog), 0, (GInstanceInitFunc) print_dialog_instance_init, NULL };
	GType print_dialog_type_id;
	print_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PrintDialog", &g_define_type_info, 0);
	PrintDialog_private_offset = g_type_add_instance_private (print_dialog_type_id, sizeof (PrintDialogPrivate));
	return print_dialog_type_id;
}

GType
print_dialog_get_type (void)
{
	static volatile gsize print_dialog_type_id__once = 0;
	if (g_once_init_enter (&print_dialog_type_id__once)) {
		GType print_dialog_type_id;
		print_dialog_type_id = print_dialog_get_type_once ();
		g_once_init_leave (&print_dialog_type_id__once, print_dialog_type_id);
	}
	return print_dialog_type_id__once;
}

