/* sudoku-view.c generated by valac 0.56.4, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "libsudoku.h"
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL_VIEW (sudoku_cell_view_get_type ())
#define SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellView))
#define SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))
#define IS_SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL_VIEW))
#define IS_SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL_VIEW))
#define SUDOKU_CELL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))

typedef struct _SudokuCellView SudokuCellView;
typedef struct _SudokuCellViewClass SudokuCellViewClass;
typedef struct _SudokuCellViewPrivate SudokuCellViewPrivate;

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
enum  {
	SUDOKU_CELL_VIEW_0_PROPERTY,
	SUDOKU_CELL_VIEW_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_VIEW_SELECTED_PROPERTY,
	SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_view_properties[SUDOKU_CELL_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;

struct _SudokuCellView {
	GtkDrawingArea parent_instance;
	SudokuCellViewPrivate * priv;
	GtkGestureLongPress* long_press;
};

struct _SudokuCellViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _SudokuCellViewPrivate {
	gdouble size_ratio;
	GtkPopover* popover;
	GtkPopover* earmark_popover;
	SudokuGame* game;
	gint row;
	gint col;
	gboolean initialized_earmarks;
	gboolean left_control;
	gboolean right_control;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	NumberPicker* number_picker;
	NumberPicker* earmark_picker;
	GtkEventControllerKey* key_controller;
};

struct _SudokuView {
	GtkAspectFrame parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
};

struct _SudokuViewClass {
	GtkAspectFrameClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCellView** cells;
	gint cells_length1;
	gint cells_length2;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkDrawingArea* drawing;
	GtkGrid* grid;
	GtkEventControllerKey* key_controller;
	gint selected_row;
	gint selected_col;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block9Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	SudokuCellView* cell;
	gint cell_row;
	gint cell_col;
};

static gint SudokuCellView_private_offset;
static gpointer sudoku_cell_view_parent_class = NULL;
static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCellView, g_object_unref)
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN SudokuCellView* sudoku_cell_view_new (gint row,
                                      gint col,
                                      SudokuGame** game);
VALA_EXTERN SudokuCellView* sudoku_cell_view_construct (GType object_type,
                                            gint row,
                                            gint col,
                                            SudokuGame** game);
static inline void sudoku_cell_view_init_keyboard (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_value (SudokuCellView* self,
                                 gint value);
VALA_EXTERN gboolean sudoku_cell_view_get_is_fixed (SudokuCellView* self);
static gboolean sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                                        GtkWidget* widget,
                                        GdkEventFocus* event);
static gboolean _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
VALA_EXTERN void sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                       gint row,
                                       gint col,
                                       gint old_val,
                                       gint new_val);
static void _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                                 gint row,
                                                                 gint col,
                                                                 gint old_val,
                                                                 gint new_val,
                                                                 gpointer self);
static gboolean sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                                   GdkEventButton* event);
VALA_EXTERN void sudoku_cell_view_hide_both_popovers (SudokuCellView* self);
static void sudoku_cell_view_show_earmark_picker (SudokuCellView* self);
static void sudoku_cell_view_show_number_picker (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_long_press_event (SudokuCellView* self);
static void sudoku_cell_view_create_earmark_picker (SudokuCellView* self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
static void __lambda10_ (SudokuCellView* self,
                  gint number,
                  gboolean state);
VALA_EXTERN gint sudoku_cell_view_get_value (SudokuCellView* self);
static void ___lambda10__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                       gint number,
                                                       gboolean active,
                                                       gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda7_ (SudokuCellView* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda7__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
static void __lambda8_ (SudokuCellView* self);
static void sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                       GtkPopover** popover,
                                       NumberPicker** picker);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean __lambda9_ (SudokuCellView* self);
static gboolean ___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                 GdkEventFocus* event,
                                                 gpointer self);
static void __lambda11_ (SudokuCellView* self);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda12_ (SudokuCellView* self);
static gboolean ___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static gboolean sudoku_cell_view_warn_incorrect_solution (SudokuCellView* self);
static gint sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                      const gchar* key_name);
static inline gboolean sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                          GtkEventControllerKey* _key_controller,
                                          guint keyval,
                                          guint keycode,
                                          GdkModifierType state);
static gboolean _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                guint keyval,
                                                                                guint keycode,
                                                                                GdkModifierType state,
                                                                                gpointer self);
static inline void sudoku_cell_view_on_key_release (SudokuCellView* self,
                                      GtkEventControllerKey* _key_controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType state);
static void _sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                             guint keyval,
                                                                             guint keycode,
                                                                             GdkModifierType state,
                                                                             gpointer self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static gboolean sudoku_cell_view_real_draw (GtkWidget* base,
                                     cairo_t* c);
static void sudoku_cell_view_print_centered (SudokuCellView* self,
                                      cairo_t* c,
                                      const gchar* text,
                                      gdouble width,
                                      gdouble height);
VALA_EXTERN void sudoku_cell_view_clear (SudokuCellView* self);
VALA_EXTERN gboolean sudoku_cell_view_get_show_possibilities (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                              gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_initialize_earmarks (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_initialize_earmarks (SudokuCellView* self,
                                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_show_warnings (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_show_extra_warnings (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_show_extra_warnings (SudokuCellView* self,
                                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_selected (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_selected (SudokuCellView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_highlighted_background (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_highlighted_background (SudokuCellView* self,
                                                  gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_highlighted_value (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_highlighted_value (SudokuCellView* self,
                                             gboolean value);
static void sudoku_cell_view_finalize (GObject * obj);
static GType sudoku_cell_view_get_type_once (void);
static void _vala_sudoku_cell_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_sudoku_cell_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
static gboolean sudoku_view_on_key_pressed (SudokuView* self,
                                     GtkEventControllerKey* _key_controller,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean sudoku_view_draw_board (SudokuView* self,
                                 cairo_t* c);
static gboolean _sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                                  cairo_t* cr,
                                                  gpointer self);
static void __lambda13_ (SudokuView* self);
static void ___lambda13__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ________lambda14_ (Block10Data* _data10_);
static void sudoku_view_update_highlights (SudokuView* self);
static gboolean _________lambda14__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                       GdkEventFocus* event,
                                                       gpointer self);
static gboolean ________lambda15_ (Block10Data* _data10_);
static gboolean _________lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                        GdkEventFocus* event,
                                                        gpointer self);
static void ________lambda16_ (Block10Data* _data10_);
static void _________lambda16__gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                        gdouble x,
                                                        gdouble y,
                                                        gpointer self);
static void ________lambda17_ (Block10Data* _data10_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda17__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static gboolean _sudoku_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_hide_popovers (SudokuView* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

const GdkRGBA selected_bg_color = {0.7, 0.8, 0.9, 1.0};
const GdkRGBA fixed_cell_color = {0.8, 0.8, 0.8, 1.0};
const GdkRGBA highlight_color = {0.93, 0.93, 0.93, 1.0};
const GdkRGBA free_cell_color = {1.0, 1.0, 1.0, 1.0};

static inline gpointer
sudoku_cell_view_get_instance_private (SudokuCellView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCellView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 129 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 437 "sudoku-view.c"
}

static gboolean
_sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_focus_out_cb ((SudokuCellView*) self, _sender, event);
#line 145 "../src/sudoku-view.vala"
	return result;
#line 449 "sudoku-view.c"
}

static void
_sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self)
{
#line 146 "../src/sudoku-view.vala"
	sudoku_cell_view_cell_changed_cb ((SudokuCellView*) self, row, col, old_val, new_val);
#line 462 "sudoku-view.c"
}

SudokuCellView*
sudoku_cell_view_construct (GType object_type,
                            gint row,
                            gint col,
                            SudokuGame** game)
{
	SudokuCellView * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 127 "../src/sudoku-view.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 127 "../src/sudoku-view.vala"
	self = (SudokuCellView*) g_object_new (object_type, NULL);
#line 129 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 129 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 129 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 130 "../src/sudoku-view.vala"
	self->priv->row = row;
#line 131 "../src/sudoku-view.vala"
	self->priv->col = col;
#line 133 "../src/sudoku-view.vala"
	sudoku_cell_view_init_keyboard (self);
#line 135 "../src/sudoku-view.vala"
	_tmp1_ = (*game)->board;
#line 135 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, sudoku_board_get (_tmp1_, row, col));
#line 139 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 140 "../src/sudoku-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK);
#line 142 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 142 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 142 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 142 "../src/sudoku-view.vala"
		_tmp2_ = (*game)->mode == GAME_MODE_PLAY;
#line 509 "sudoku-view.c"
	} else {
#line 142 "../src/sudoku-view.vala"
		_tmp2_ = FALSE;
#line 513 "sudoku-view.c"
	}
#line 142 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 143 "../src/sudoku-view.vala"
		return self;
#line 519 "sudoku-view.c"
	}
#line 145 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event, self, 0);
#line 146 "../src/sudoku-view.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 127 "../src/sudoku-view.vala"
	return self;
#line 527 "sudoku-view.c"
}

SudokuCellView*
sudoku_cell_view_new (gint row,
                      gint col,
                      SudokuGame** game)
{
#line 127 "../src/sudoku-view.vala"
	return sudoku_cell_view_construct (TYPE_SUDOKU_CELL_VIEW, row, col, game);
#line 537 "sudoku-view.c"
}

static gboolean
sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                          GdkEventButton* event)
{
	SudokuCellView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	gboolean _tmp11_ = FALSE;
	GtkPopover* _tmp12_;
	gboolean result;
#line 149 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 149 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 151 "../src/sudoku-view.vala"
	if (event->button != ((guint) 1)) {
#line 151 "../src/sudoku-view.vala"
		_tmp0_ = event->button != ((guint) 3);
#line 561 "sudoku-view.c"
	} else {
#line 151 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 565 "sudoku-view.c"
	}
#line 151 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 152 "../src/sudoku-view.vala"
		result = FALSE;
#line 152 "../src/sudoku-view.vala"
		return result;
#line 573 "sudoku-view.c"
	}
#line 154 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) self, "is-focus", &_tmp1_, NULL);
#line 154 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 155 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 583 "sudoku-view.c"
	}
#line 156 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->game;
#line 156 "../src/sudoku-view.vala"
	if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 589 "sudoku-view.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 156 "../src/sudoku-view.vala"
		_tmp6_ = sudoku_cell_view_get_is_fixed (self);
#line 156 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_;
#line 156 "../src/sudoku-view.vala"
		if (_tmp7_) {
#line 156 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 601 "sudoku-view.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 156 "../src/sudoku-view.vala"
			_tmp8_ = self->priv->game;
#line 156 "../src/sudoku-view.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 156 "../src/sudoku-view.vala"
			_tmp10_ = _tmp9_;
#line 156 "../src/sudoku-view.vala"
			_tmp5_ = _tmp10_;
#line 614 "sudoku-view.c"
		}
#line 156 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_;
#line 618 "sudoku-view.c"
	} else {
#line 156 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 622 "sudoku-view.c"
	}
#line 156 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 157 "../src/sudoku-view.vala"
		result = FALSE;
#line 157 "../src/sudoku-view.vala"
		return result;
#line 630 "sudoku-view.c"
	}
#line 159 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->popover;
#line 159 "../src/sudoku-view.vala"
	if (_tmp12_ != NULL) {
#line 159 "../src/sudoku-view.vala"
		_tmp11_ = TRUE;
#line 638 "sudoku-view.c"
	} else {
		GtkPopover* _tmp13_;
#line 159 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->earmark_popover;
#line 159 "../src/sudoku-view.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 645 "sudoku-view.c"
	}
#line 159 "../src/sudoku-view.vala"
	if (_tmp11_) {
#line 161 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 162 "../src/sudoku-view.vala"
		result = FALSE;
#line 162 "../src/sudoku-view.vala"
		return result;
#line 655 "sudoku-view.c"
	}
#line 165 "../src/sudoku-view.vala"
	if (event->button == ((guint) 1)) {
#line 659 "sudoku-view.c"
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
#line 167 "../src/sudoku-view.vala"
		if (!self->priv->_show_possibilities) {
#line 167 "../src/sudoku-view.vala"
			_tmp15_ = (event->state & GDK_CONTROL_MASK) > 0;
#line 666 "sudoku-view.c"
		} else {
#line 167 "../src/sudoku-view.vala"
			_tmp15_ = FALSE;
#line 670 "sudoku-view.c"
		}
#line 167 "../src/sudoku-view.vala"
		if (_tmp15_) {
#line 674 "sudoku-view.c"
			SudokuGame* _tmp16_;
#line 167 "../src/sudoku-view.vala"
			_tmp16_ = self->priv->game;
#line 167 "../src/sudoku-view.vala"
			_tmp14_ = _tmp16_->mode == GAME_MODE_PLAY;
#line 680 "sudoku-view.c"
		} else {
#line 167 "../src/sudoku-view.vala"
			_tmp14_ = FALSE;
#line 684 "sudoku-view.c"
		}
#line 167 "../src/sudoku-view.vala"
		if (_tmp14_) {
#line 168 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 690 "sudoku-view.c"
		} else {
#line 170 "../src/sudoku-view.vala"
			sudoku_cell_view_show_number_picker (self);
#line 694 "sudoku-view.c"
		}
	} else {
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
#line 172 "../src/sudoku-view.vala"
		if (!self->priv->_show_possibilities) {
#line 172 "../src/sudoku-view.vala"
			_tmp18_ = event->button == ((guint) 3);
#line 703 "sudoku-view.c"
		} else {
#line 172 "../src/sudoku-view.vala"
			_tmp18_ = FALSE;
#line 707 "sudoku-view.c"
		}
#line 172 "../src/sudoku-view.vala"
		if (_tmp18_) {
#line 711 "sudoku-view.c"
			SudokuGame* _tmp19_;
#line 172 "../src/sudoku-view.vala"
			_tmp19_ = self->priv->game;
#line 172 "../src/sudoku-view.vala"
			_tmp17_ = _tmp19_->mode == GAME_MODE_PLAY;
#line 717 "sudoku-view.c"
		} else {
#line 172 "../src/sudoku-view.vala"
			_tmp17_ = FALSE;
#line 721 "sudoku-view.c"
		}
#line 172 "../src/sudoku-view.vala"
		if (_tmp17_) {
#line 173 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 727 "sudoku-view.c"
		}
	}
#line 175 "../src/sudoku-view.vala"
	result = FALSE;
#line 175 "../src/sudoku-view.vala"
	return result;
#line 734 "sudoku-view.c"
}

void
sudoku_cell_view_long_press_event (SudokuCellView* self)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
#line 178 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->game;
#line 180 "../src/sudoku-view.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 748 "sudoku-view.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 180 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 180 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 180 "../src/sudoku-view.vala"
		if (_tmp4_) {
#line 180 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 760 "sudoku-view.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 180 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->game;
#line 180 "../src/sudoku-view.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 180 "../src/sudoku-view.vala"
			_tmp7_ = _tmp6_;
#line 180 "../src/sudoku-view.vala"
			_tmp2_ = _tmp7_;
#line 773 "sudoku-view.c"
		}
#line 180 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_;
#line 777 "sudoku-view.c"
	} else {
#line 180 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 781 "sudoku-view.c"
	}
#line 180 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 181 "../src/sudoku-view.vala"
		return;
#line 787 "sudoku-view.c"
	}
#line 183 "../src/sudoku-view.vala"
	sudoku_cell_view_show_earmark_picker (self);
#line 791 "sudoku-view.c"
}

static void
__lambda10_ (SudokuCellView* self,
             gint number,
             gboolean state)
{
	SudokuGame* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 190 "../src/sudoku-view.vala"
	if (state) {
#line 806 "sudoku-view.c"
		SudokuGame* _tmp0_;
#line 191 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->game;
#line 191 "../src/sudoku-view.vala"
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
#line 812 "sudoku-view.c"
	} else {
		SudokuGame* _tmp1_;
#line 193 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->game;
#line 193 "../src/sudoku-view.vala"
		sudoku_game_disable_earmark (_tmp1_, self->priv->row, self->priv->col, number);
#line 819 "sudoku-view.c"
	}
#line 194 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->game;
#line 194 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_cell_view_get_value (self);
#line 194 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 194 "../src/sudoku-view.vala"
	_tmp5_ = sudoku_cell_view_get_value (self);
#line 194 "../src/sudoku-view.vala"
	_tmp6_ = _tmp5_;
#line 194 "../src/sudoku-view.vala"
	g_signal_emit_by_name (_tmp2_, "cell-changed", self->priv->row, self->priv->col, _tmp4_, _tmp6_);
#line 195 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 835 "sudoku-view.c"
}

static void
___lambda10__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                  gint number,
                                                  gboolean active,
                                                  gpointer self)
{
#line 189 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuCellView*) self, number, active);
#line 846 "sudoku-view.c"
}

static void
sudoku_cell_view_create_earmark_picker (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	NumberPicker* _tmp3_;
#line 186 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 188 "../src/sudoku-view.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
#line 188 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 188 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 188 "../src/sudoku-view.vala"
	self->priv->earmark_picker = _tmp1_;
#line 189 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_picker;
#line 189 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp2_, "earmark-state-changed", (GCallback) ___lambda10__number_picker_earmark_state_changed, self, 0);
#line 197 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_picker;
#line 197 "../src/sudoku-view.vala"
	number_picker_set_earmarks (_tmp3_, self->priv->row, self->priv->col);
#line 876 "sudoku-view.c"
}

static void
__lambda7_ (SudokuCellView* self,
            NumberPicker* o,
            gint number)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	GtkPopover* _tmp2_;
#line 206 "../src/sudoku-view.vala"
	g_return_if_fail (o != NULL);
#line 207 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, number);
#line 208 "../src/sudoku-view.vala"
	if (number == 0) {
#line 209 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 895 "sudoku-view.c"
	}
#line 210 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 210 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 210 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 212 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->popover;
#line 212 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 907 "sudoku-view.c"
}

static void
___lambda7__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 206 "../src/sudoku-view.vala"
	__lambda7_ ((SudokuCellView*) self, _sender, number);
#line 917 "sudoku-view.c"
}

static void
__lambda8_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 221 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 221 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 221 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 221 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 222 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->popover, &self->priv->number_picker);
#line 936 "sudoku-view.c"
	}
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 220 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuCellView*) self);
#line 947 "sudoku-view.c"
}

static gboolean
__lambda9_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result;
#line 225 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 225 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 226 "../src/sudoku-view.vala"
	result = TRUE;
#line 226 "../src/sudoku-view.vala"
	return result;
#line 963 "sudoku-view.c"
}

static gboolean
___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                        GdkEventFocus* event,
                                        gpointer self)
{
	gboolean result;
	result = __lambda9_ ((SudokuCellView*) self);
#line 224 "../src/sudoku-view.vala"
	return result;
#line 975 "sudoku-view.c"
}

static void
sudoku_cell_view_show_number_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp2_;
	NumberPicker* _tmp3_;
	NumberPicker* _tmp4_;
	NumberPicker* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	NumberPicker* _tmp10_;
	GtkPopover* _tmp11_;
	GtkPopover* _tmp12_;
	GtkPopover* _tmp13_;
	GtkPopover* _tmp14_;
	GtkPopover* _tmp15_;
#line 200 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 202 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1002 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 203 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->earmark_popover;
#line 203 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1008 "sudoku-view.c"
	}
#line 205 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->game;
#line 205 "../src/sudoku-view.vala"
	_tmp3_ = number_picker_new (&_tmp2_->board, FALSE);
#line 205 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 205 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 205 "../src/sudoku-view.vala"
	self->priv->number_picker = _tmp3_;
#line 206 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->number_picker;
#line 206 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp4_, "number-picked", (GCallback) ___lambda7__number_picker_number_picked, self, 0);
#line 214 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->number_picker;
#line 214 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_cell_view_get_value (self);
#line 214 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 214 "../src/sudoku-view.vala"
	number_picker_set_clear_button_visibility (_tmp5_, _tmp7_ != 0);
#line 216 "../src/sudoku-view.vala"
	_tmp8_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 216 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp8_);
#line 216 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 216 "../src/sudoku-view.vala"
	self->priv->popover = _tmp8_;
#line 217 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->popover;
#line 217 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->number_picker;
#line 217 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 218 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->popover;
#line 218 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp11_, FALSE);
#line 219 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->popover;
#line 219 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp12_, GTK_POS_BOTTOM);
#line 220 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->popover;
#line 220 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::visible", (GCallback) ___lambda8__g_object_notify, self, 0);
#line 224 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->popover;
#line 224 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp14_, "focus-out-event", (GCallback) ___lambda9__gtk_widget_focus_out_event, self, 0);
#line 229 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->popover;
#line 229 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp15_);
#line 1066 "sudoku-view.c"
}

static void
__lambda11_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 244 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 244 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 244 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 244 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 245 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->earmark_popover, &self->priv->earmark_picker);
#line 1085 "sudoku-view.c"
	}
}

static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 243 "../src/sudoku-view.vala"
	__lambda11_ ((SudokuCellView*) self);
#line 1096 "sudoku-view.c"
}

static gboolean
__lambda12_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result;
#line 248 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 248 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 249 "../src/sudoku-view.vala"
	result = TRUE;
#line 249 "../src/sudoku-view.vala"
	return result;
#line 1112 "sudoku-view.c"
}

static gboolean
___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda12_ ((SudokuCellView*) self);
#line 247 "../src/sudoku-view.vala"
	return result;
#line 1124 "sudoku-view.c"
}

static void
sudoku_cell_view_show_earmark_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	NumberPicker* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
#line 232 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 234 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1145 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 235 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 235 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1151 "sudoku-view.c"
	}
#line 237 "../src/sudoku-view.vala"
	sudoku_cell_view_create_earmark_picker (self);
#line 239 "../src/sudoku-view.vala"
	_tmp2_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 239 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp2_);
#line 239 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 239 "../src/sudoku-view.vala"
	self->priv->earmark_popover = _tmp2_;
#line 240 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_popover;
#line 240 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->earmark_picker;
#line 240 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 241 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->earmark_popover;
#line 241 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp5_, FALSE);
#line 242 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->earmark_popover;
#line 242 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp6_, GTK_POS_BOTTOM);
#line 243 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->earmark_popover;
#line 243 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::visible", (GCallback) ___lambda11__g_object_notify, self, 0);
#line 247 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->earmark_popover;
#line 247 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp8_, "focus-out-event", (GCallback) ___lambda12__gtk_widget_focus_out_event, self, 0);
#line 252 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->earmark_popover;
#line 252 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 1189 "sudoku-view.c"
}

static void
sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                  GtkPopover** popover,
                                  NumberPicker** picker)
{
#line 255 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/sudoku-view.vala"
	g_return_if_fail (*popover != NULL);
#line 255 "../src/sudoku-view.vala"
	g_return_if_fail (*picker != NULL);
#line 257 "../src/sudoku-view.vala"
	_g_object_unref0 (*picker);
#line 257 "../src/sudoku-view.vala"
	*picker = NULL;
#line 258 "../src/sudoku-view.vala"
	if ((*popover) != NULL) {
#line 260 "../src/sudoku-view.vala"
		gtk_widget_destroy ((GtkWidget*) (*popover));
#line 261 "../src/sudoku-view.vala"
		_g_object_unref0 (*popover);
#line 261 "../src/sudoku-view.vala"
		*popover = NULL;
#line 264 "../src/sudoku-view.vala"
		if (sudoku_cell_view_warn_incorrect_solution (self)) {
#line 265 "../src/sudoku-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1219 "sudoku-view.c"
		}
	}
}

void
sudoku_cell_view_hide_both_popovers (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
#line 269 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 271 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1235 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 272 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 272 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1241 "sudoku-view.c"
	}
#line 273 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_popover;
#line 273 "../src/sudoku-view.vala"
	if (_tmp2_ != NULL) {
#line 1247 "sudoku-view.c"
		GtkPopover* _tmp3_;
#line 274 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->earmark_popover;
#line 274 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1253 "sudoku-view.c"
	}
}

static gboolean
sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                               GtkWidget* widget,
                               GdkEventFocus* event)
{
	gboolean result;
#line 277 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 277 "../src/sudoku-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 277 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 279 "../src/sudoku-view.vala"
	sudoku_cell_view_hide_both_popovers (self);
#line 280 "../src/sudoku-view.vala"
	result = FALSE;
#line 280 "../src/sudoku-view.vala"
	return result;
#line 1275 "sudoku-view.c"
}

static gint
sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                 const gchar* key_name)
{
	gboolean _tmp0_ = FALSE;
	gint result;
#line 284 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 284 "../src/sudoku-view.vala"
	g_return_val_if_fail (key_name != NULL, 0);
#line 287 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_0") == 0) {
#line 287 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1292 "sudoku-view.c"
	} else {
#line 287 "../src/sudoku-view.vala"
		_tmp0_ = g_strcmp0 (key_name, "0") == 0;
#line 1296 "sudoku-view.c"
	}
#line 287 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 288 "../src/sudoku-view.vala"
		result = 0;
#line 288 "../src/sudoku-view.vala"
		return result;
#line 1304 "sudoku-view.c"
	}
#line 289 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_1") == 0) {
#line 290 "../src/sudoku-view.vala"
		result = 1;
#line 290 "../src/sudoku-view.vala"
		return result;
#line 1312 "sudoku-view.c"
	}
#line 291 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_2") == 0) {
#line 292 "../src/sudoku-view.vala"
		result = 2;
#line 292 "../src/sudoku-view.vala"
		return result;
#line 1320 "sudoku-view.c"
	}
#line 293 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_3") == 0) {
#line 294 "../src/sudoku-view.vala"
		result = 3;
#line 294 "../src/sudoku-view.vala"
		return result;
#line 1328 "sudoku-view.c"
	}
#line 295 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_4") == 0) {
#line 296 "../src/sudoku-view.vala"
		result = 4;
#line 296 "../src/sudoku-view.vala"
		return result;
#line 1336 "sudoku-view.c"
	}
#line 297 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_5") == 0) {
#line 298 "../src/sudoku-view.vala"
		result = 5;
#line 298 "../src/sudoku-view.vala"
		return result;
#line 1344 "sudoku-view.c"
	}
#line 299 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_6") == 0) {
#line 300 "../src/sudoku-view.vala"
		result = 6;
#line 300 "../src/sudoku-view.vala"
		return result;
#line 1352 "sudoku-view.c"
	}
#line 301 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_7") == 0) {
#line 302 "../src/sudoku-view.vala"
		result = 7;
#line 302 "../src/sudoku-view.vala"
		return result;
#line 1360 "sudoku-view.c"
	}
#line 303 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_8") == 0) {
#line 304 "../src/sudoku-view.vala"
		result = 8;
#line 304 "../src/sudoku-view.vala"
		return result;
#line 1368 "sudoku-view.c"
	}
#line 305 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_9") == 0) {
#line 306 "../src/sudoku-view.vala"
		result = 9;
#line 306 "../src/sudoku-view.vala"
		return result;
#line 1376 "sudoku-view.c"
	}
#line 307 "../src/sudoku-view.vala"
	result = -1;
#line 307 "../src/sudoku-view.vala"
	return result;
#line 1382 "sudoku-view.c"
}

static gboolean
_sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                       guint keyval,
                                                                       guint keycode,
                                                                       GdkModifierType state,
                                                                       gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_on_key_pressed ((SudokuCellView*) self, _sender, keyval, keycode, state);
#line 313 "../src/sudoku-view.vala"
	return result;
#line 1396 "sudoku-view.c"
}

static void
_sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
#line 314 "../src/sudoku-view.vala"
	sudoku_cell_view_on_key_release ((SudokuCellView*) self, _sender, keyval, keycode, state);
#line 1408 "sudoku-view.c"
}

static inline void
sudoku_cell_view_init_keyboard (SudokuCellView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GtkEventControllerKey* _tmp2_;
#line 310 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/sudoku-view.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 312 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 312 "../src/sudoku-view.vala"
	self->priv->key_controller = _tmp0_;
#line 313 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->key_controller;
#line 313 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 314 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->key_controller;
#line 314 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp2_, "key-released", (GCallback) _sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released, self, 0);
#line 1433 "sudoku-view.c"
}

static inline gboolean
sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                 GtkEventControllerKey* _key_controller,
                                 guint keyval,
                                 guint keycode,
                                 GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	gchar* k_name = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gint k_no = 0;
	const gchar* _tmp10_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
	const gchar* _tmp38_;
	gboolean result;
#line 317 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 317 "../src/sudoku-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 319 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 320 "../src/sudoku-view.vala"
		self->priv->left_control = TRUE;
#line 1466 "sudoku-view.c"
	}
#line 321 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_R) {
#line 322 "../src/sudoku-view.vala"
		self->priv->right_control = TRUE;
#line 1472 "sudoku-view.c"
	}
#line 324 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->game;
#line 324 "../src/sudoku-view.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 1478 "sudoku-view.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 324 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 324 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 324 "../src/sudoku-view.vala"
		if (_tmp4_) {
#line 324 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 1490 "sudoku-view.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 324 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->game;
#line 324 "../src/sudoku-view.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 324 "../src/sudoku-view.vala"
			_tmp7_ = _tmp6_;
#line 324 "../src/sudoku-view.vala"
			_tmp2_ = _tmp7_;
#line 1503 "sudoku-view.c"
		}
#line 324 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_;
#line 1507 "sudoku-view.c"
	} else {
#line 324 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1511 "sudoku-view.c"
	}
#line 324 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 325 "../src/sudoku-view.vala"
		result = FALSE;
#line 325 "../src/sudoku-view.vala"
		return result;
#line 1519 "sudoku-view.c"
	}
#line 326 "../src/sudoku-view.vala"
	_tmp8_ = gdk_keyval_name (keyval);
#line 326 "../src/sudoku-view.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 326 "../src/sudoku-view.vala"
	k_name = _tmp9_;
#line 327 "../src/sudoku-view.vala"
	_tmp10_ = k_name;
#line 327 "../src/sudoku-view.vala"
	k_no = atoi (_tmp10_);
#line 329 "../src/sudoku-view.vala"
	if (k_no == 0) {
#line 1533 "sudoku-view.c"
		const gchar* _tmp11_;
#line 330 "../src/sudoku-view.vala"
		_tmp11_ = k_name;
#line 330 "../src/sudoku-view.vala"
		k_no = sudoku_cell_view_key_map_keypad (self, _tmp11_);
#line 1539 "sudoku-view.c"
	}
#line 331 "../src/sudoku-view.vala"
	if (k_no >= 1) {
#line 331 "../src/sudoku-view.vala"
		_tmp12_ = k_no <= 9;
#line 1545 "sudoku-view.c"
	} else {
#line 331 "../src/sudoku-view.vala"
		_tmp12_ = FALSE;
#line 1549 "sudoku-view.c"
	}
#line 331 "../src/sudoku-view.vala"
	if (_tmp12_) {
#line 1553 "sudoku-view.c"
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkPopover* _tmp15_;
		gboolean want_earmark = FALSE;
		gboolean _tmp17_ = FALSE;
#line 333 "../src/sudoku-view.vala"
		_tmp15_ = self->priv->earmark_popover;
#line 333 "../src/sudoku-view.vala"
		if (_tmp15_ != NULL) {
#line 1563 "sudoku-view.c"
			GtkPopover* _tmp16_;
#line 333 "../src/sudoku-view.vala"
			_tmp16_ = self->priv->earmark_popover;
#line 333 "../src/sudoku-view.vala"
			_tmp14_ = gtk_widget_is_visible ((GtkWidget*) _tmp16_);
#line 1569 "sudoku-view.c"
		} else {
#line 333 "../src/sudoku-view.vala"
			_tmp14_ = FALSE;
#line 1573 "sudoku-view.c"
		}
#line 333 "../src/sudoku-view.vala"
		if (_tmp14_) {
#line 333 "../src/sudoku-view.vala"
			_tmp13_ = TRUE;
#line 1579 "sudoku-view.c"
		} else {
#line 334 "../src/sudoku-view.vala"
			_tmp13_ = (state & GDK_CONTROL_MASK) > 0;
#line 1583 "sudoku-view.c"
		}
#line 333 "../src/sudoku-view.vala"
		want_earmark = _tmp13_;
#line 335 "../src/sudoku-view.vala"
		if (want_earmark) {
#line 1589 "sudoku-view.c"
			SudokuGame* _tmp18_;
#line 335 "../src/sudoku-view.vala"
			_tmp18_ = self->priv->game;
#line 335 "../src/sudoku-view.vala"
			_tmp17_ = _tmp18_->mode == GAME_MODE_PLAY;
#line 1595 "sudoku-view.c"
		} else {
#line 335 "../src/sudoku-view.vala"
			_tmp17_ = FALSE;
#line 1599 "sudoku-view.c"
		}
#line 335 "../src/sudoku-view.vala"
		if (_tmp17_) {
#line 1603 "sudoku-view.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp19_;
			SudokuBoard* _tmp20_;
			NumberPicker* _tmp23_;
#line 337 "../src/sudoku-view.vala"
			_tmp19_ = self->priv->game;
#line 337 "../src/sudoku-view.vala"
			_tmp20_ = _tmp19_->board;
#line 337 "../src/sudoku-view.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp20_, self->priv->row, self->priv->col, k_no);
#line 338 "../src/sudoku-view.vala"
			if (new_state) {
#line 1616 "sudoku-view.c"
				SudokuGame* _tmp21_;
#line 339 "../src/sudoku-view.vala"
				_tmp21_ = self->priv->game;
#line 339 "../src/sudoku-view.vala"
				sudoku_game_enable_earmark (_tmp21_, self->priv->row, self->priv->col, k_no);
#line 1622 "sudoku-view.c"
			} else {
				SudokuGame* _tmp22_;
#line 341 "../src/sudoku-view.vala"
				_tmp22_ = self->priv->game;
#line 341 "../src/sudoku-view.vala"
				sudoku_game_disable_earmark (_tmp22_, self->priv->row, self->priv->col, k_no);
#line 1629 "sudoku-view.c"
			}
#line 343 "../src/sudoku-view.vala"
			_tmp23_ = self->priv->earmark_picker;
#line 343 "../src/sudoku-view.vala"
			if (_tmp23_ != NULL) {
#line 1635 "sudoku-view.c"
				NumberPicker* _tmp24_;
#line 344 "../src/sudoku-view.vala"
				_tmp24_ = self->priv->earmark_picker;
#line 344 "../src/sudoku-view.vala"
				number_picker_set_earmark (_tmp24_, self->priv->row, self->priv->col, k_no - 1, new_state);
#line 1641 "sudoku-view.c"
			}
#line 346 "../src/sudoku-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1645 "sudoku-view.c"
		} else {
			SudokuGame* _tmp25_;
			SudokuBoard* _tmp26_;
#line 350 "../src/sudoku-view.vala"
			sudoku_cell_view_set_value (self, k_no);
#line 351 "../src/sudoku-view.vala"
			_tmp25_ = self->priv->game;
#line 351 "../src/sudoku-view.vala"
			_tmp26_ = _tmp25_->board;
#line 351 "../src/sudoku-view.vala"
			sudoku_board_disable_all_earmarks (_tmp26_, self->priv->row, self->priv->col);
#line 352 "../src/sudoku-view.vala"
			sudoku_cell_view_hide_both_popovers (self);
#line 1659 "sudoku-view.c"
		}
#line 354 "../src/sudoku-view.vala"
		result = TRUE;
#line 354 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 354 "../src/sudoku-view.vala"
		return result;
#line 1667 "sudoku-view.c"
	}
#line 356 "../src/sudoku-view.vala"
	if (k_no == 0) {
#line 356 "../src/sudoku-view.vala"
		_tmp28_ = TRUE;
#line 1673 "sudoku-view.c"
	} else {
		const gchar* _tmp29_;
#line 356 "../src/sudoku-view.vala"
		_tmp29_ = k_name;
#line 356 "../src/sudoku-view.vala"
		_tmp28_ = g_strcmp0 (_tmp29_, "BackSpace") == 0;
#line 1680 "sudoku-view.c"
	}
#line 356 "../src/sudoku-view.vala"
	if (_tmp28_) {
#line 356 "../src/sudoku-view.vala"
		_tmp27_ = TRUE;
#line 1686 "sudoku-view.c"
	} else {
		const gchar* _tmp30_;
#line 356 "../src/sudoku-view.vala"
		_tmp30_ = k_name;
#line 356 "../src/sudoku-view.vala"
		_tmp27_ = g_strcmp0 (_tmp30_, "Delete") == 0;
#line 1693 "sudoku-view.c"
	}
#line 356 "../src/sudoku-view.vala"
	if (_tmp27_) {
#line 358 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, 0);
#line 359 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 360 "../src/sudoku-view.vala"
		result = TRUE;
#line 360 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 360 "../src/sudoku-view.vala"
		return result;
#line 1707 "sudoku-view.c"
	}
#line 363 "../src/sudoku-view.vala"
	_tmp33_ = k_name;
#line 363 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp33_, "space") == 0) {
#line 363 "../src/sudoku-view.vala"
		_tmp32_ = TRUE;
#line 1715 "sudoku-view.c"
	} else {
		const gchar* _tmp34_;
#line 363 "../src/sudoku-view.vala"
		_tmp34_ = k_name;
#line 363 "../src/sudoku-view.vala"
		_tmp32_ = g_strcmp0 (_tmp34_, "Return") == 0;
#line 1722 "sudoku-view.c"
	}
#line 363 "../src/sudoku-view.vala"
	if (_tmp32_) {
#line 363 "../src/sudoku-view.vala"
		_tmp31_ = TRUE;
#line 1728 "sudoku-view.c"
	} else {
		const gchar* _tmp35_;
#line 363 "../src/sudoku-view.vala"
		_tmp35_ = k_name;
#line 363 "../src/sudoku-view.vala"
		_tmp31_ = g_strcmp0 (_tmp35_, "KP_Enter") == 0;
#line 1735 "sudoku-view.c"
	}
#line 363 "../src/sudoku-view.vala"
	if (_tmp31_) {
#line 1739 "sudoku-view.c"
		GtkPopover* _tmp36_;
#line 365 "../src/sudoku-view.vala"
		_tmp36_ = self->priv->popover;
#line 365 "../src/sudoku-view.vala"
		if (_tmp36_ != NULL) {
#line 1745 "sudoku-view.c"
			GtkPopover* _tmp37_;
#line 367 "../src/sudoku-view.vala"
			_tmp37_ = self->priv->popover;
#line 367 "../src/sudoku-view.vala"
			gtk_widget_hide ((GtkWidget*) _tmp37_);
#line 368 "../src/sudoku-view.vala"
			result = FALSE;
#line 368 "../src/sudoku-view.vala"
			_g_free0 (k_name);
#line 368 "../src/sudoku-view.vala"
			return result;
#line 1757 "sudoku-view.c"
		}
#line 370 "../src/sudoku-view.vala"
		sudoku_cell_view_show_number_picker (self);
#line 371 "../src/sudoku-view.vala"
		result = TRUE;
#line 371 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 371 "../src/sudoku-view.vala"
		return result;
#line 1767 "sudoku-view.c"
	}
#line 374 "../src/sudoku-view.vala"
	_tmp38_ = k_name;
#line 374 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp38_, "Escape") == 0) {
#line 376 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 377 "../src/sudoku-view.vala"
		result = TRUE;
#line 377 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 377 "../src/sudoku-view.vala"
		return result;
#line 1781 "sudoku-view.c"
	}
#line 380 "../src/sudoku-view.vala"
	result = FALSE;
#line 380 "../src/sudoku-view.vala"
	_g_free0 (k_name);
#line 380 "../src/sudoku-view.vala"
	return result;
#line 1789 "sudoku-view.c"
}

static inline void
sudoku_cell_view_on_key_release (SudokuCellView* self,
                                 GtkEventControllerKey* _key_controller,
                                 guint keyval,
                                 guint keycode,
                                 GdkModifierType state)
{
	gboolean control_released = FALSE;
	gboolean _tmp0_ = FALSE;
#line 383 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/sudoku-view.vala"
	g_return_if_fail (_key_controller != NULL);
#line 385 "../src/sudoku-view.vala"
	control_released = FALSE;
#line 386 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 388 "../src/sudoku-view.vala"
		self->priv->left_control = FALSE;
#line 389 "../src/sudoku-view.vala"
		control_released = TRUE;
#line 1813 "sudoku-view.c"
	}
#line 391 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_R) {
#line 393 "../src/sudoku-view.vala"
		self->priv->right_control = FALSE;
#line 394 "../src/sudoku-view.vala"
		control_released = TRUE;
#line 1821 "sudoku-view.c"
	}
#line 398 "../src/sudoku-view.vala"
	if (control_released) {
#line 398 "../src/sudoku-view.vala"
		_tmp0_ = sudoku_cell_view_warn_incorrect_solution (self);
#line 1827 "sudoku-view.c"
	} else {
#line 398 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1831 "sudoku-view.c"
	}
#line 398 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 399 "../src/sudoku-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 1837 "sudoku-view.c"
	}
}

static gboolean
sudoku_cell_view_real_draw (GtkWidget* base,
                            cairo_t* c)
{
	SudokuCellView * self;
	GdkRGBA background_color = {0};
	gboolean _tmp0_ = FALSE;
	GdkRGBA _tmp21_;
	GdkRGBA _tmp22_;
	GdkRGBA _tmp23_;
	GdkRGBA _tmp24_;
	gboolean _tmp25_ = FALSE;
	SudokuGame* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gboolean* _tmp71_;
	gint _tmp71__length1;
	gboolean _tmp104_ = FALSE;
	gboolean result;
#line 402 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 402 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 405 "../src/sudoku-view.vala"
	if (self->priv->_selected) {
#line 1874 "sudoku-view.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 405 "../src/sudoku-view.vala"
		g_object_get ((GtkWidget*) self, "is-focus", &_tmp1_, NULL);
#line 405 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_;
#line 405 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_;
#line 1883 "sudoku-view.c"
	} else {
#line 405 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1887 "sudoku-view.c"
	}
#line 405 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 406 "../src/sudoku-view.vala"
		background_color = selected_bg_color;
#line 1893 "sudoku-view.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 407 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 407 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 407 "../src/sudoku-view.vala"
		if (_tmp4_) {
#line 408 "../src/sudoku-view.vala"
			background_color = fixed_cell_color;
#line 1905 "sudoku-view.c"
		} else {
#line 409 "../src/sudoku-view.vala"
			if (self->priv->_highlighted_background) {
#line 410 "../src/sudoku-view.vala"
				background_color = highlight_color;
#line 1911 "sudoku-view.c"
			} else {
#line 412 "../src/sudoku-view.vala"
				background_color = free_cell_color;
#line 1915 "sudoku-view.c"
			}
		}
	}
#line 416 "../src/sudoku-view.vala"
	if (sudoku_cell_view_warn_incorrect_solution (self)) {
#line 1921 "sudoku-view.c"
		gboolean cell_error = FALSE;
		gint solution = 0;
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 418 "../src/sudoku-view.vala"
		cell_error = FALSE;
#line 419 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->game;
#line 419 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->board;
#line 419 "../src/sudoku-view.vala"
		solution = sudoku_board_get_solution (_tmp6_, self->priv->row, self->priv->col);
#line 420 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_cell_view_get_value (self);
#line 420 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 420 "../src/sudoku-view.vala"
		if (_tmp8_ != 0) {
#line 1942 "sudoku-view.c"
			gint _tmp9_;
			gint _tmp10_;
#line 423 "../src/sudoku-view.vala"
			_tmp9_ = sudoku_cell_view_get_value (self);
#line 423 "../src/sudoku-view.vala"
			_tmp10_ = _tmp9_;
#line 423 "../src/sudoku-view.vala"
			cell_error = _tmp10_ != solution;
#line 1951 "sudoku-view.c"
		} else {
			gboolean* marks = NULL;
			SudokuGame* _tmp11_;
			SudokuBoard* _tmp12_;
			gint _tmp13_ = 0;
			gboolean* _tmp14_;
			gint marks_length1;
			gint _marks_size_;
			gboolean earmarked = FALSE;
			gboolean solution_found = FALSE;
			gboolean _tmp20_ = FALSE;
#line 428 "../src/sudoku-view.vala"
			_tmp11_ = self->priv->game;
#line 428 "../src/sudoku-view.vala"
			_tmp12_ = _tmp11_->board;
#line 428 "../src/sudoku-view.vala"
			_tmp14_ = sudoku_board_get_earmarks (_tmp12_, self->priv->row, self->priv->col, &_tmp13_);
#line 428 "../src/sudoku-view.vala"
			marks = _tmp14_;
#line 428 "../src/sudoku-view.vala"
			marks_length1 = _tmp13_;
#line 428 "../src/sudoku-view.vala"
			_marks_size_ = marks_length1;
#line 429 "../src/sudoku-view.vala"
			earmarked = FALSE;
#line 430 "../src/sudoku-view.vala"
			solution_found = FALSE;
#line 1979 "sudoku-view.c"
			{
				gint num = 0;
#line 431 "../src/sudoku-view.vala"
				num = 1;
#line 1984 "sudoku-view.c"
				{
					gboolean _tmp15_ = FALSE;
#line 431 "../src/sudoku-view.vala"
					_tmp15_ = TRUE;
#line 431 "../src/sudoku-view.vala"
					while (TRUE) {
#line 1991 "sudoku-view.c"
						gboolean* _tmp17_;
						gint _tmp17__length1;
						gboolean* _tmp18_;
						gint _tmp18__length1;
						gboolean _tmp19_;
#line 431 "../src/sudoku-view.vala"
						if (!_tmp15_) {
#line 1999 "sudoku-view.c"
							gint _tmp16_;
#line 431 "../src/sudoku-view.vala"
							_tmp16_ = num;
#line 431 "../src/sudoku-view.vala"
							num = _tmp16_ + 1;
#line 2005 "sudoku-view.c"
						}
#line 431 "../src/sudoku-view.vala"
						_tmp15_ = FALSE;
#line 431 "../src/sudoku-view.vala"
						_tmp17_ = marks;
#line 431 "../src/sudoku-view.vala"
						_tmp17__length1 = marks_length1;
#line 431 "../src/sudoku-view.vala"
						if (!(num <= _tmp17__length1)) {
#line 431 "../src/sudoku-view.vala"
							break;
#line 2017 "sudoku-view.c"
						}
#line 433 "../src/sudoku-view.vala"
						_tmp18_ = marks;
#line 433 "../src/sudoku-view.vala"
						_tmp18__length1 = marks_length1;
#line 433 "../src/sudoku-view.vala"
						_tmp19_ = _tmp18_[num - 1];
#line 433 "../src/sudoku-view.vala"
						if (_tmp19_) {
#line 435 "../src/sudoku-view.vala"
							earmarked = TRUE;
#line 436 "../src/sudoku-view.vala"
							if (num == solution) {
#line 437 "../src/sudoku-view.vala"
								solution_found = TRUE;
#line 2033 "sudoku-view.c"
							}
						}
					}
				}
			}
#line 440 "../src/sudoku-view.vala"
			if (earmarked) {
#line 440 "../src/sudoku-view.vala"
				_tmp20_ = !solution_found;
#line 2043 "sudoku-view.c"
			} else {
#line 440 "../src/sudoku-view.vala"
				_tmp20_ = FALSE;
#line 2047 "sudoku-view.c"
			}
#line 440 "../src/sudoku-view.vala"
			if (_tmp20_) {
#line 441 "../src/sudoku-view.vala"
				cell_error = TRUE;
#line 2053 "sudoku-view.c"
			}
#line 420 "../src/sudoku-view.vala"
			marks = (g_free (marks), NULL);
#line 2057 "sudoku-view.c"
		}
#line 445 "../src/sudoku-view.vala"
		if (cell_error) {
#line 447 "../src/sudoku-view.vala"
			background_color.green = background_color.green * 0.6;
#line 448 "../src/sudoku-view.vala"
			background_color.blue = background_color.blue * 0.6;
#line 2065 "sudoku-view.c"
		}
	}
#line 452 "../src/sudoku-view.vala"
	_tmp21_ = background_color;
#line 452 "../src/sudoku-view.vala"
	_tmp22_ = background_color;
#line 452 "../src/sudoku-view.vala"
	_tmp23_ = background_color;
#line 452 "../src/sudoku-view.vala"
	_tmp24_ = background_color;
#line 452 "../src/sudoku-view.vala"
	cairo_set_source_rgba (c, _tmp21_.red, _tmp22_.green, _tmp23_.blue, _tmp24_.alpha);
#line 453 "../src/sudoku-view.vala"
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 454 "../src/sudoku-view.vala"
	cairo_fill (c);
#line 456 "../src/sudoku-view.vala"
	if (self->priv->_show_warnings) {
#line 2084 "sudoku-view.c"
		SudokuGame* _tmp26_;
		SudokuBoard* _tmp27_;
		GeeSet* _tmp28_;
		Coord _tmp29_ = {0};
#line 456 "../src/sudoku-view.vala"
		_tmp26_ = self->priv->game;
#line 456 "../src/sudoku-view.vala"
		_tmp27_ = _tmp26_->board;
#line 456 "../src/sudoku-view.vala"
		_tmp28_ = _tmp27_->broken_coords;
#line 456 "../src/sudoku-view.vala"
		coord_init (&_tmp29_, self->priv->row, self->priv->col);
#line 456 "../src/sudoku-view.vala"
		_tmp25_ = gee_collection_contains ((GeeCollection*) _tmp28_, &_tmp29_);
#line 2099 "sudoku-view.c"
	} else {
#line 456 "../src/sudoku-view.vala"
		_tmp25_ = FALSE;
#line 2103 "sudoku-view.c"
	}
#line 456 "../src/sudoku-view.vala"
	if (_tmp25_) {
#line 457 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 2109 "sudoku-view.c"
	} else {
#line 458 "../src/sudoku-view.vala"
		if (self->priv->_highlighted_value) {
#line 459 "../src/sudoku-view.vala"
			cairo_set_source_rgb (c, 0.2, 0.4, 0.9);
#line 2115 "sudoku-view.c"
		} else {
#line 460 "../src/sudoku-view.vala"
			if (self->priv->_selected) {
#line 461 "../src/sudoku-view.vala"
				cairo_set_source_rgb (c, 0.2, 0.2, 0.2);
#line 2121 "sudoku-view.c"
			} else {
#line 463 "../src/sudoku-view.vala"
				cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 2125 "sudoku-view.c"
			}
		}
	}
#line 465 "../src/sudoku-view.vala"
	_tmp30_ = self->priv->game;
#line 465 "../src/sudoku-view.vala"
	_tmp31_ = sudoku_game_get_paused (_tmp30_);
#line 465 "../src/sudoku-view.vala"
	_tmp32_ = _tmp31_;
#line 465 "../src/sudoku-view.vala"
	if (_tmp32_) {
#line 466 "../src/sudoku-view.vala"
		result = FALSE;
#line 466 "../src/sudoku-view.vala"
		return result;
#line 2141 "sudoku-view.c"
	}
#line 468 "../src/sudoku-view.vala"
	_tmp33_ = sudoku_cell_view_get_value (self);
#line 468 "../src/sudoku-view.vala"
	_tmp34_ = _tmp33_;
#line 468 "../src/sudoku-view.vala"
	if (_tmp34_ != 0) {
#line 2149 "sudoku-view.c"
		gdouble height = 0.0;
		gdouble width = 0.0;
		gchar* text = NULL;
		gint _tmp35_;
		gint _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
#line 470 "../src/sudoku-view.vala"
		height = (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 471 "../src/sudoku-view.vala"
		width = (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 472 "../src/sudoku-view.vala"
		_tmp35_ = sudoku_cell_view_get_value (self);
#line 472 "../src/sudoku-view.vala"
		_tmp36_ = _tmp35_;
#line 472 "../src/sudoku-view.vala"
		_tmp37_ = g_strdup_printf ("%d", _tmp36_);
#line 472 "../src/sudoku-view.vala"
		text = _tmp37_;
#line 474 "../src/sudoku-view.vala"
		cairo_set_font_size (c, height / self->priv->size_ratio);
#line 475 "../src/sudoku-view.vala"
		_tmp38_ = text;
#line 475 "../src/sudoku-view.vala"
		sudoku_cell_view_print_centered (self, c, _tmp38_, width, height);
#line 476 "../src/sudoku-view.vala"
		result = FALSE;
#line 476 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 476 "../src/sudoku-view.vala"
		return result;
#line 2181 "sudoku-view.c"
	}
#line 479 "../src/sudoku-view.vala"
	_tmp40_ = sudoku_cell_view_get_is_fixed (self);
#line 479 "../src/sudoku-view.vala"
	_tmp41_ = _tmp40_;
#line 479 "../src/sudoku-view.vala"
	if (_tmp41_) {
#line 2189 "sudoku-view.c"
		SudokuGame* _tmp42_;
#line 479 "../src/sudoku-view.vala"
		_tmp42_ = self->priv->game;
#line 479 "../src/sudoku-view.vala"
		_tmp39_ = _tmp42_->mode == GAME_MODE_PLAY;
#line 2195 "sudoku-view.c"
	} else {
#line 479 "../src/sudoku-view.vala"
		_tmp39_ = FALSE;
#line 2199 "sudoku-view.c"
	}
#line 479 "../src/sudoku-view.vala"
	if (_tmp39_) {
#line 480 "../src/sudoku-view.vala"
		result = FALSE;
#line 480 "../src/sudoku-view.vala"
		return result;
#line 2207 "sudoku-view.c"
	}
#line 482 "../src/sudoku-view.vala"
	marks = NULL;
#line 482 "../src/sudoku-view.vala"
	marks_length1 = 0;
#line 482 "../src/sudoku-view.vala"
	_marks_size_ = marks_length1;
#line 483 "../src/sudoku-view.vala"
	if (!self->priv->_show_possibilities) {
#line 2217 "sudoku-view.c"
		SudokuGame* _tmp61_;
		SudokuBoard* _tmp62_;
		gint _tmp63_ = 0;
		gboolean* _tmp64_;
#line 486 "../src/sudoku-view.vala"
		if (!self->priv->initialized_earmarks) {
#line 2224 "sudoku-view.c"
			gboolean _tmp43_ = FALSE;
			gboolean _tmp44_ = FALSE;
#line 490 "../src/sudoku-view.vala"
			if (self->priv->_initialize_earmarks) {
#line 2229 "sudoku-view.c"
				SudokuGame* _tmp45_;
#line 490 "../src/sudoku-view.vala"
				_tmp45_ = self->priv->game;
#line 490 "../src/sudoku-view.vala"
				_tmp44_ = _tmp45_->mode == GAME_MODE_PLAY;
#line 2235 "sudoku-view.c"
			} else {
#line 490 "../src/sudoku-view.vala"
				_tmp44_ = FALSE;
#line 2239 "sudoku-view.c"
			}
#line 490 "../src/sudoku-view.vala"
			if (_tmp44_) {
#line 2243 "sudoku-view.c"
				SudokuGame* _tmp46_;
				SudokuBoard* _tmp47_;
				gdouble _tmp48_;
				gdouble _tmp49_;
#line 491 "../src/sudoku-view.vala"
				_tmp46_ = self->priv->game;
#line 491 "../src/sudoku-view.vala"
				_tmp47_ = _tmp46_->board;
#line 491 "../src/sudoku-view.vala"
				_tmp48_ = sudoku_board_get_previous_played_time (_tmp47_);
#line 491 "../src/sudoku-view.vala"
				_tmp49_ = _tmp48_;
#line 491 "../src/sudoku-view.vala"
				_tmp43_ = _tmp49_ == 0.0;
#line 2258 "sudoku-view.c"
			} else {
#line 490 "../src/sudoku-view.vala"
				_tmp43_ = FALSE;
#line 2262 "sudoku-view.c"
			}
#line 490 "../src/sudoku-view.vala"
			if (_tmp43_) {
#line 2266 "sudoku-view.c"
				SudokuGame* _tmp50_;
				SudokuBoard* _tmp51_;
				gint _tmp52_ = 0;
				gboolean* _tmp53_;
#line 493 "../src/sudoku-view.vala"
				_tmp50_ = self->priv->game;
#line 493 "../src/sudoku-view.vala"
				_tmp51_ = _tmp50_->board;
#line 493 "../src/sudoku-view.vala"
				_tmp53_ = sudoku_board_get_possibilities_as_bool_array (_tmp51_, self->priv->row, self->priv->col, &_tmp52_);
#line 493 "../src/sudoku-view.vala"
				marks = (g_free (marks), NULL);
#line 493 "../src/sudoku-view.vala"
				marks = _tmp53_;
#line 493 "../src/sudoku-view.vala"
				marks_length1 = _tmp52_;
#line 493 "../src/sudoku-view.vala"
				_marks_size_ = marks_length1;
#line 2285 "sudoku-view.c"
				{
					gint num = 0;
#line 494 "../src/sudoku-view.vala"
					num = 1;
#line 2290 "sudoku-view.c"
					{
						gboolean _tmp54_ = FALSE;
#line 494 "../src/sudoku-view.vala"
						_tmp54_ = TRUE;
#line 494 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2297 "sudoku-view.c"
							gboolean* _tmp56_;
							gint _tmp56__length1;
							gboolean* _tmp57_;
							gint _tmp57__length1;
							gboolean _tmp58_;
#line 494 "../src/sudoku-view.vala"
							if (!_tmp54_) {
#line 2305 "sudoku-view.c"
								gint _tmp55_;
#line 494 "../src/sudoku-view.vala"
								_tmp55_ = num;
#line 494 "../src/sudoku-view.vala"
								num = _tmp55_ + 1;
#line 2311 "sudoku-view.c"
							}
#line 494 "../src/sudoku-view.vala"
							_tmp54_ = FALSE;
#line 494 "../src/sudoku-view.vala"
							_tmp56_ = marks;
#line 494 "../src/sudoku-view.vala"
							_tmp56__length1 = marks_length1;
#line 494 "../src/sudoku-view.vala"
							if (!(num <= _tmp56__length1)) {
#line 494 "../src/sudoku-view.vala"
								break;
#line 2323 "sudoku-view.c"
							}
#line 496 "../src/sudoku-view.vala"
							_tmp57_ = marks;
#line 496 "../src/sudoku-view.vala"
							_tmp57__length1 = marks_length1;
#line 496 "../src/sudoku-view.vala"
							_tmp58_ = _tmp57_[num - 1];
#line 496 "../src/sudoku-view.vala"
							if (_tmp58_) {
#line 2333 "sudoku-view.c"
								SudokuGame* _tmp59_;
								SudokuBoard* _tmp60_;
#line 498 "../src/sudoku-view.vala"
								_tmp59_ = self->priv->game;
#line 498 "../src/sudoku-view.vala"
								_tmp60_ = _tmp59_->board;
#line 498 "../src/sudoku-view.vala"
								sudoku_board_enable_earmark (_tmp60_, self->priv->row, self->priv->col, num);
#line 2342 "sudoku-view.c"
							}
						}
					}
				}
			}
#line 502 "../src/sudoku-view.vala"
			self->priv->initialized_earmarks = TRUE;
#line 2350 "sudoku-view.c"
		}
#line 505 "../src/sudoku-view.vala"
		_tmp61_ = self->priv->game;
#line 505 "../src/sudoku-view.vala"
		_tmp62_ = _tmp61_->board;
#line 505 "../src/sudoku-view.vala"
		_tmp64_ = sudoku_board_get_earmarks (_tmp62_, self->priv->row, self->priv->col, &_tmp63_);
#line 505 "../src/sudoku-view.vala"
		marks = (g_free (marks), NULL);
#line 505 "../src/sudoku-view.vala"
		marks = _tmp64_;
#line 505 "../src/sudoku-view.vala"
		marks_length1 = _tmp63_;
#line 505 "../src/sudoku-view.vala"
		_marks_size_ = marks_length1;
#line 2366 "sudoku-view.c"
	} else {
		gint _tmp65_;
		gint _tmp66_;
#line 507 "../src/sudoku-view.vala"
		_tmp65_ = sudoku_cell_view_get_value (self);
#line 507 "../src/sudoku-view.vala"
		_tmp66_ = _tmp65_;
#line 507 "../src/sudoku-view.vala"
		if (_tmp66_ == 0) {
#line 2376 "sudoku-view.c"
			SudokuGame* _tmp67_;
			SudokuBoard* _tmp68_;
			gint _tmp69_ = 0;
			gboolean* _tmp70_;
#line 509 "../src/sudoku-view.vala"
			_tmp67_ = self->priv->game;
#line 509 "../src/sudoku-view.vala"
			_tmp68_ = _tmp67_->board;
#line 509 "../src/sudoku-view.vala"
			_tmp70_ = sudoku_board_get_possibilities_as_bool_array (_tmp68_, self->priv->row, self->priv->col, &_tmp69_);
#line 509 "../src/sudoku-view.vala"
			marks = (g_free (marks), NULL);
#line 509 "../src/sudoku-view.vala"
			marks = _tmp70_;
#line 509 "../src/sudoku-view.vala"
			marks_length1 = _tmp69_;
#line 509 "../src/sudoku-view.vala"
			_marks_size_ = marks_length1;
#line 2395 "sudoku-view.c"
		}
	}
#line 512 "../src/sudoku-view.vala"
	_tmp71_ = marks;
#line 512 "../src/sudoku-view.vala"
	_tmp71__length1 = marks_length1;
#line 512 "../src/sudoku-view.vala"
	if (_tmp71_ != NULL) {
#line 2404 "sudoku-view.c"
		gdouble possibility_size = 0.0;
		gdouble height = 0.0;
		SudokuGame* _tmp72_;
		SudokuBoard* _tmp73_;
		gint _tmp74_;
		gint _tmp75_;
		gdouble width = 0.0;
		SudokuGame* _tmp76_;
		SudokuBoard* _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		gint num = 0;
#line 514 "../src/sudoku-view.vala"
		possibility_size = (gtk_widget_get_allocated_height ((GtkWidget*) self) / self->priv->size_ratio) / 2;
#line 515 "../src/sudoku-view.vala"
		cairo_set_font_size (c, possibility_size);
#line 517 "../src/sudoku-view.vala"
		_tmp72_ = self->priv->game;
#line 517 "../src/sudoku-view.vala"
		_tmp73_ = _tmp72_->board;
#line 517 "../src/sudoku-view.vala"
		_tmp74_ = sudoku_board_get_block_rows (_tmp73_);
#line 517 "../src/sudoku-view.vala"
		_tmp75_ = _tmp74_;
#line 517 "../src/sudoku-view.vala"
		height = ((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / _tmp75_;
#line 518 "../src/sudoku-view.vala"
		_tmp76_ = self->priv->game;
#line 518 "../src/sudoku-view.vala"
		_tmp77_ = _tmp76_->board;
#line 518 "../src/sudoku-view.vala"
		_tmp78_ = sudoku_board_get_block_cols (_tmp77_);
#line 518 "../src/sudoku-view.vala"
		_tmp79_ = _tmp78_;
#line 518 "../src/sudoku-view.vala"
		width = ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / _tmp79_;
#line 520 "../src/sudoku-view.vala"
		num = 0;
#line 2443 "sudoku-view.c"
		{
			gint row_tmp = 0;
#line 521 "../src/sudoku-view.vala"
			row_tmp = 0;
#line 2448 "sudoku-view.c"
			{
				gboolean _tmp80_ = FALSE;
#line 521 "../src/sudoku-view.vala"
				_tmp80_ = TRUE;
#line 521 "../src/sudoku-view.vala"
				while (TRUE) {
#line 2455 "sudoku-view.c"
					SudokuGame* _tmp82_;
					SudokuBoard* _tmp83_;
					gint _tmp84_;
					gint _tmp85_;
#line 521 "../src/sudoku-view.vala"
					if (!_tmp80_) {
#line 2462 "sudoku-view.c"
						gint _tmp81_;
#line 521 "../src/sudoku-view.vala"
						_tmp81_ = row_tmp;
#line 521 "../src/sudoku-view.vala"
						row_tmp = _tmp81_ + 1;
#line 2468 "sudoku-view.c"
					}
#line 521 "../src/sudoku-view.vala"
					_tmp80_ = FALSE;
#line 521 "../src/sudoku-view.vala"
					_tmp82_ = self->priv->game;
#line 521 "../src/sudoku-view.vala"
					_tmp83_ = _tmp82_->board;
#line 521 "../src/sudoku-view.vala"
					_tmp84_ = sudoku_board_get_block_rows (_tmp83_);
#line 521 "../src/sudoku-view.vala"
					_tmp85_ = _tmp84_;
#line 521 "../src/sudoku-view.vala"
					if (!(row_tmp < _tmp85_)) {
#line 521 "../src/sudoku-view.vala"
						break;
#line 2484 "sudoku-view.c"
					}
					{
						gint col_tmp = 0;
#line 523 "../src/sudoku-view.vala"
						col_tmp = 0;
#line 2490 "sudoku-view.c"
						{
							gboolean _tmp86_ = FALSE;
#line 523 "../src/sudoku-view.vala"
							_tmp86_ = TRUE;
#line 523 "../src/sudoku-view.vala"
							while (TRUE) {
#line 2497 "sudoku-view.c"
								SudokuGame* _tmp88_;
								SudokuBoard* _tmp89_;
								gint _tmp90_;
								gint _tmp91_;
								gint _tmp92_;
								gboolean* _tmp93_;
								gint _tmp93__length1;
								gboolean _tmp94_;
#line 523 "../src/sudoku-view.vala"
								if (!_tmp86_) {
#line 2508 "sudoku-view.c"
									gint _tmp87_;
#line 523 "../src/sudoku-view.vala"
									_tmp87_ = col_tmp;
#line 523 "../src/sudoku-view.vala"
									col_tmp = _tmp87_ + 1;
#line 2514 "sudoku-view.c"
								}
#line 523 "../src/sudoku-view.vala"
								_tmp86_ = FALSE;
#line 523 "../src/sudoku-view.vala"
								_tmp88_ = self->priv->game;
#line 523 "../src/sudoku-view.vala"
								_tmp89_ = _tmp88_->board;
#line 523 "../src/sudoku-view.vala"
								_tmp90_ = sudoku_board_get_block_cols (_tmp89_);
#line 523 "../src/sudoku-view.vala"
								_tmp91_ = _tmp90_;
#line 523 "../src/sudoku-view.vala"
								if (!(col_tmp < _tmp91_)) {
#line 523 "../src/sudoku-view.vala"
									break;
#line 2530 "sudoku-view.c"
								}
#line 525 "../src/sudoku-view.vala"
								_tmp92_ = num;
#line 525 "../src/sudoku-view.vala"
								num = _tmp92_ + 1;
#line 527 "../src/sudoku-view.vala"
								_tmp93_ = marks;
#line 527 "../src/sudoku-view.vala"
								_tmp93__length1 = marks_length1;
#line 527 "../src/sudoku-view.vala"
								_tmp94_ = _tmp93_[num - 1];
#line 527 "../src/sudoku-view.vala"
								if (_tmp94_) {
#line 2544 "sudoku-view.c"
									gboolean _tmp95_ = FALSE;
									gchar* text = NULL;
									gchar* _tmp98_;
									SudokuGame* _tmp99_;
									SudokuBoard* _tmp100_;
									gint _tmp101_;
									gint _tmp102_;
									const gchar* _tmp103_;
#line 529 "../src/sudoku-view.vala"
									if (self->priv->_show_warnings) {
#line 2555 "sudoku-view.c"
										SudokuGame* _tmp96_;
										SudokuBoard* _tmp97_;
#line 529 "../src/sudoku-view.vala"
										_tmp96_ = self->priv->game;
#line 529 "../src/sudoku-view.vala"
										_tmp97_ = _tmp96_->board;
#line 529 "../src/sudoku-view.vala"
										_tmp95_ = !sudoku_board_is_possible (_tmp97_, self->priv->row, self->priv->col, num);
#line 2564 "sudoku-view.c"
									} else {
#line 529 "../src/sudoku-view.vala"
										_tmp95_ = FALSE;
#line 2568 "sudoku-view.c"
									}
#line 529 "../src/sudoku-view.vala"
									if (_tmp95_) {
#line 530 "../src/sudoku-view.vala"
										cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 2574 "sudoku-view.c"
									} else {
#line 532 "../src/sudoku-view.vala"
										cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 2578 "sudoku-view.c"
									}
#line 534 "../src/sudoku-view.vala"
									_tmp98_ = g_strdup_printf ("%d", num);
#line 534 "../src/sudoku-view.vala"
									text = _tmp98_;
#line 536 "../src/sudoku-view.vala"
									cairo_save (c);
#line 537 "../src/sudoku-view.vala"
									_tmp99_ = self->priv->game;
#line 537 "../src/sudoku-view.vala"
									_tmp100_ = _tmp99_->board;
#line 537 "../src/sudoku-view.vala"
									_tmp101_ = sudoku_board_get_block_rows (_tmp100_);
#line 537 "../src/sudoku-view.vala"
									_tmp102_ = _tmp101_;
#line 537 "../src/sudoku-view.vala"
									cairo_translate (c, col_tmp * width, ((_tmp102_ - row_tmp) - 1) * height);
#line 538 "../src/sudoku-view.vala"
									_tmp103_ = text;
#line 538 "../src/sudoku-view.vala"
									sudoku_cell_view_print_centered (self, c, _tmp103_, width, height);
#line 539 "../src/sudoku-view.vala"
									cairo_restore (c);
#line 527 "../src/sudoku-view.vala"
									_g_free0 (text);
#line 2604 "sudoku-view.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 545 "../src/sudoku-view.vala"
	if (self->priv->_show_warnings) {
#line 2615 "sudoku-view.c"
		gboolean _tmp105_ = FALSE;
		gint _tmp106_;
		gint _tmp107_;
#line 545 "../src/sudoku-view.vala"
		_tmp106_ = sudoku_cell_view_get_value (self);
#line 545 "../src/sudoku-view.vala"
		_tmp107_ = _tmp106_;
#line 545 "../src/sudoku-view.vala"
		if (_tmp107_ == 0) {
#line 2625 "sudoku-view.c"
			SudokuGame* _tmp108_;
			SudokuBoard* _tmp109_;
#line 545 "../src/sudoku-view.vala"
			_tmp108_ = self->priv->game;
#line 545 "../src/sudoku-view.vala"
			_tmp109_ = _tmp108_->board;
#line 545 "../src/sudoku-view.vala"
			_tmp105_ = sudoku_board_count_possibilities (_tmp109_, self->priv->row, self->priv->col) == 0;
#line 2634 "sudoku-view.c"
		} else {
#line 545 "../src/sudoku-view.vala"
			_tmp105_ = FALSE;
#line 2638 "sudoku-view.c"
		}
#line 545 "../src/sudoku-view.vala"
		_tmp104_ = _tmp105_;
#line 2642 "sudoku-view.c"
	} else {
#line 545 "../src/sudoku-view.vala"
		_tmp104_ = FALSE;
#line 2646 "sudoku-view.c"
	}
#line 545 "../src/sudoku-view.vala"
	if (_tmp104_) {
#line 547 "../src/sudoku-view.vala"
		cairo_set_font_size (c, gtk_widget_get_allocated_height ((GtkWidget*) self) / self->priv->size_ratio);
#line 548 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 549 "../src/sudoku-view.vala"
		sudoku_cell_view_print_centered (self, c, "X", (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 2656 "sudoku-view.c"
	}
#line 552 "../src/sudoku-view.vala"
	result = FALSE;
#line 552 "../src/sudoku-view.vala"
	marks = (g_free (marks), NULL);
#line 552 "../src/sudoku-view.vala"
	return result;
#line 2664 "sudoku-view.c"
}

static void
sudoku_cell_view_print_centered (SudokuCellView* self,
                                 cairo_t* c,
                                 const gchar* text,
                                 gdouble width,
                                 gdouble height)
{
	cairo_font_extents_t font_extents = {0};
	cairo_font_extents_t _tmp0_ = {0};
	cairo_text_extents_t text_extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
	cairo_font_extents_t _tmp4_;
	cairo_font_extents_t _tmp5_;
#line 555 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/sudoku-view.vala"
	g_return_if_fail (c != NULL);
#line 555 "../src/sudoku-view.vala"
	g_return_if_fail (text != NULL);
#line 558 "../src/sudoku-view.vala"
	cairo_font_extents (c, &_tmp0_);
#line 558 "../src/sudoku-view.vala"
	font_extents = _tmp0_;
#line 561 "../src/sudoku-view.vala"
	cairo_text_extents (c, text, &_tmp1_);
#line 561 "../src/sudoku-view.vala"
	text_extents = _tmp1_;
#line 563 "../src/sudoku-view.vala"
	_tmp2_ = text_extents;
#line 563 "../src/sudoku-view.vala"
	_tmp3_ = text_extents;
#line 563 "../src/sudoku-view.vala"
	_tmp4_ = font_extents;
#line 563 "../src/sudoku-view.vala"
	_tmp5_ = font_extents;
#line 563 "../src/sudoku-view.vala"
	cairo_move_to (c, ((width - _tmp2_.width) / 2) - _tmp3_.x_bearing, ((height + _tmp4_.height) / 2) - _tmp5_.descent);
#line 567 "../src/sudoku-view.vala"
	cairo_show_text (c, text);
#line 2708 "sudoku-view.c"
}

void
sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val)
{
	gboolean _tmp0_ = FALSE;
#line 570 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 572 "../src/sudoku-view.vala"
	if (row == self->priv->row) {
#line 572 "../src/sudoku-view.vala"
		_tmp0_ = col == self->priv->col;
#line 2725 "sudoku-view.c"
	} else {
#line 572 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2729 "sudoku-view.c"
	}
#line 572 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 574 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, new_val);
#line 575 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 2737 "sudoku-view.c"
	}
}

void
sudoku_cell_view_clear (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 579 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 581 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 581 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 581 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 2754 "sudoku-view.c"
}

static gboolean
sudoku_cell_view_warn_incorrect_solution (SudokuCellView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 587 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 593 "../src/sudoku-view.vala"
	if (self->priv->_show_extra_warnings) {
#line 2770 "sudoku-view.c"
		GtkPopover* _tmp5_;
#line 594 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->popover;
#line 594 "../src/sudoku-view.vala"
		_tmp4_ = _tmp5_ == NULL;
#line 2776 "sudoku-view.c"
	} else {
#line 593 "../src/sudoku-view.vala"
		_tmp4_ = FALSE;
#line 2780 "sudoku-view.c"
	}
#line 593 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 2784 "sudoku-view.c"
		GtkPopover* _tmp6_;
#line 594 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->earmark_popover;
#line 594 "../src/sudoku-view.vala"
		_tmp3_ = _tmp6_ == NULL;
#line 2790 "sudoku-view.c"
	} else {
#line 593 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 2794 "sudoku-view.c"
	}
#line 593 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 595 "../src/sudoku-view.vala"
		_tmp2_ = !self->priv->left_control;
#line 2800 "sudoku-view.c"
	} else {
#line 593 "../src/sudoku-view.vala"
		_tmp2_ = FALSE;
#line 2804 "sudoku-view.c"
	}
#line 593 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 595 "../src/sudoku-view.vala"
		_tmp1_ = !self->priv->right_control;
#line 2810 "sudoku-view.c"
	} else {
#line 593 "../src/sudoku-view.vala"
		_tmp1_ = FALSE;
#line 2814 "sudoku-view.c"
	}
#line 593 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 2818 "sudoku-view.c"
		SudokuGame* _tmp7_;
		SudokuBoard* _tmp8_;
#line 596 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->game;
#line 596 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_->board;
#line 596 "../src/sudoku-view.vala"
		_tmp0_ = sudoku_board_solved (_tmp8_);
#line 2827 "sudoku-view.c"
	} else {
#line 593 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2831 "sudoku-view.c"
	}
#line 593 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 593 "../src/sudoku-view.vala"
	return result;
#line 2837 "sudoku-view.c"
}

gint
sudoku_cell_view_get_value (SudokuCellView* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 47 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 47 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 47 "../src/sudoku-view.vala"
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
#line 47 "../src/sudoku-view.vala"
	return result;
#line 2856 "sudoku-view.c"
}

void
sudoku_cell_view_set_value (SudokuCellView* self,
                            gint value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuGame* _tmp7_;
	SudokuBoard* _tmp8_;
	SudokuGame* _tmp9_;
#line 48 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_cell_view_get_is_fixed (self);
#line 50 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 50 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 2876 "sudoku-view.c"
		SudokuGame* _tmp2_;
#line 52 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->game;
#line 52 "../src/sudoku-view.vala"
		if (_tmp2_->mode == GAME_MODE_PLAY) {
#line 53 "../src/sudoku-view.vala"
			return;
#line 2884 "sudoku-view.c"
		}
	}
#line 55 "../src/sudoku-view.vala"
	if (value == 0) {
#line 2889 "sudoku-view.c"
		SudokuGame* _tmp3_;
		SudokuBoard* _tmp4_;
		SudokuGame* _tmp6_;
#line 57 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->game;
#line 57 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_->board;
#line 57 "../src/sudoku-view.vala"
		if (sudoku_board_get (_tmp4_, self->priv->row, self->priv->col) != 0) {
#line 2899 "sudoku-view.c"
			SudokuGame* _tmp5_;
#line 58 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->game;
#line 58 "../src/sudoku-view.vala"
			sudoku_game_remove (_tmp5_, self->priv->row, self->priv->col);
#line 2905 "sudoku-view.c"
		}
#line 59 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->game;
#line 59 "../src/sudoku-view.vala"
		if (_tmp6_->mode == GAME_MODE_PLAY) {
#line 60 "../src/sudoku-view.vala"
			return;
#line 2913 "sudoku-view.c"
		}
	}
#line 62 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->game;
#line 62 "../src/sudoku-view.vala"
	_tmp8_ = _tmp7_->board;
#line 62 "../src/sudoku-view.vala"
	if (value == sudoku_board_get (_tmp8_, self->priv->row, self->priv->col)) {
#line 63 "../src/sudoku-view.vala"
		return;
#line 2924 "sudoku-view.c"
	}
#line 65 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->game;
#line 65 "../src/sudoku-view.vala"
	sudoku_game_insert (_tmp9_, self->priv->row, self->priv->col, value);
#line 48 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY]);
#line 2932 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_is_fixed (SudokuCellView* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
#line 71 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 71 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 71 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_->is_fixed;
#line 71 "../src/sudoku-view.vala"
	_tmp2__length1 = _tmp1_->is_fixed_length1;
#line 71 "../src/sudoku-view.vala"
	_tmp2__length2 = _tmp1_->is_fixed_length2;
#line 71 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
#line 71 "../src/sudoku-view.vala"
	result = _tmp3_;
#line 71 "../src/sudoku-view.vala"
	return result;
#line 2963 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_show_possibilities (SudokuCellView* self)
{
	gboolean result;
#line 77 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 77 "../src/sudoku-view.vala"
	return result;
#line 2976 "sudoku-view.c"
}

void
sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                         gboolean value)
{
#line 78 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 81 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 78 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2991 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_initialize_earmarks (SudokuCellView* self)
{
	gboolean result;
#line 88 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 88 "../src/sudoku-view.vala"
	return result;
#line 3004 "sudoku-view.c"
}

void
sudoku_cell_view_set_initialize_earmarks (SudokuCellView* self,
                                          gboolean value)
{
#line 89 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 92 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 89 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 3019 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_show_warnings (SudokuCellView* self)
{
	gboolean result;
#line 99 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 99 "../src/sudoku-view.vala"
	return result;
#line 3032 "sudoku-view.c"
}

void
sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                    gboolean value)
{
#line 100 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 103 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 100 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 3047 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_show_extra_warnings (SudokuCellView* self)
{
	gboolean result;
#line 110 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 110 "../src/sudoku-view.vala"
	return result;
#line 3060 "sudoku-view.c"
}

void
sudoku_cell_view_set_show_extra_warnings (SudokuCellView* self,
                                          gboolean value)
{
#line 111 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 114 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 111 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3075 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_selected (SudokuCellView* self)
{
	gboolean result;
#line 118 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../src/sudoku-view.vala"
	result = self->priv->_selected;
#line 118 "../src/sudoku-view.vala"
	return result;
#line 3088 "sudoku-view.c"
}

void
sudoku_cell_view_set_selected (SudokuCellView* self,
                               gboolean value)
{
	gboolean old_value;
#line 118 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_selected (self);
#line 118 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 118 "../src/sudoku-view.vala"
		self->priv->_selected = value;
#line 118 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY]);
#line 3106 "sudoku-view.c"
	}
}

gboolean
sudoku_cell_view_get_highlighted_background (SudokuCellView* self)
{
	gboolean result;
#line 119 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "../src/sudoku-view.vala"
	result = self->priv->_highlighted_background;
#line 119 "../src/sudoku-view.vala"
	return result;
#line 3120 "sudoku-view.c"
}

void
sudoku_cell_view_set_highlighted_background (SudokuCellView* self,
                                             gboolean value)
{
	gboolean old_value;
#line 119 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_highlighted_background (self);
#line 119 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 119 "../src/sudoku-view.vala"
		self->priv->_highlighted_background = value;
#line 119 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3138 "sudoku-view.c"
	}
}

gboolean
sudoku_cell_view_get_highlighted_value (SudokuCellView* self)
{
	gboolean result;
#line 120 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/sudoku-view.vala"
	result = self->priv->_highlighted_value;
#line 120 "../src/sudoku-view.vala"
	return result;
#line 3152 "sudoku-view.c"
}

void
sudoku_cell_view_set_highlighted_value (SudokuCellView* self,
                                        gboolean value)
{
	gboolean old_value;
#line 120 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_highlighted_value (self);
#line 120 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 120 "../src/sudoku-view.vala"
		self->priv->_highlighted_value = value;
#line 120 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3170 "sudoku-view.c"
	}
}

static void
sudoku_cell_view_class_init (SudokuCellViewClass * klass,
                             gpointer klass_data)
{
#line 25 "../src/sudoku-view.vala"
	sudoku_cell_view_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCellView_private_offset);
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) sudoku_cell_view_real_button_press_event;
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) sudoku_cell_view_real_draw;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_view_get_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_view_set_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_view_finalize;
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SELECTED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3210 "sudoku-view.c"
}

static void
sudoku_cell_view_instance_init (SudokuCellView * self,
                                gpointer klass)
{
#line 25 "../src/sudoku-view.vala"
	self->priv = sudoku_cell_view_get_instance_private (self);
#line 27 "../src/sudoku-view.vala"
	self->priv->size_ratio = (gdouble) 2;
#line 96 "../src/sudoku-view.vala"
	self->priv->_show_warnings = TRUE;
#line 107 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 3225 "sudoku-view.c"
}

static void
sudoku_cell_view_finalize (GObject * obj)
{
	SudokuCellView * self;
#line 25 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 29 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 30 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 43 "../src/sudoku-view.vala"
	_g_object_unref0 (self->long_press);
#line 122 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 123 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 125 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_cell_view_parent_class)->finalize (obj);
#line 3250 "sudoku-view.c"
}

static GType
sudoku_cell_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCellView), 0, (GInstanceInitFunc) sudoku_cell_view_instance_init, NULL };
	GType sudoku_cell_view_type_id;
	sudoku_cell_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "SudokuCellView", &g_define_type_info, 0);
	SudokuCellView_private_offset = g_type_add_instance_private (sudoku_cell_view_type_id, sizeof (SudokuCellViewPrivate));
	return sudoku_cell_view_type_id;
}

GType
sudoku_cell_view_get_type (void)
{
	static volatile gsize sudoku_cell_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_view_type_id__once)) {
		GType sudoku_cell_view_type_id;
		sudoku_cell_view_type_id = sudoku_cell_view_get_type_once ();
		g_once_init_leave (&sudoku_cell_view_type_id__once, sudoku_cell_view_type_id);
	}
	return sudoku_cell_view_type_id__once;
}

static void
_vala_sudoku_cell_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_cell_view_get_value (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_is_fixed (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_possibilities (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_initialize_earmarks (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_warnings (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_extra_warnings (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_selected (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_highlighted_background (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_highlighted_value (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 3339 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3345 "sudoku-view.c"
	}
}

static void
_vala_sudoku_cell_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, g_value_get_int (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_warnings (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_highlighted_background (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_highlighted_value (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 3407 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3413 "sudoku-view.c"
	}
}

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 620 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 622 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->selected_col >= 0;
#line 3436 "sudoku-view.c"
	} else {
#line 622 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 3440 "sudoku-view.c"
	}
#line 622 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3444 "sudoku-view.c"
		SudokuCellView** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCellView* _tmp2_;
		SudokuCellView** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuCellView* _tmp4_;
#line 624 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 624 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 624 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 624 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->priv->selected_row * _tmp1__length2) + self->priv->selected_col];
#line 624 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (_tmp2_, FALSE);
#line 625 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->cells;
#line 625 "../src/sudoku-view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 625 "../src/sudoku-view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 625 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_[(self->priv->selected_row * _tmp3__length2) + self->priv->selected_col];
#line 625 "../src/sudoku-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp4_);
#line 3473 "sudoku-view.c"
	}
#line 627 "../src/sudoku-view.vala"
	self->priv->selected_row = cell_row;
#line 628 "../src/sudoku-view.vala"
	self->priv->selected_col = cell_col;
#line 629 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 629 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->selected_col >= 0;
#line 3483 "sudoku-view.c"
	} else {
#line 629 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 3487 "sudoku-view.c"
	}
#line 629 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 3491 "sudoku-view.c"
		SudokuCellView** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuCellView* _tmp7_;
#line 631 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 631 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 631 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 631 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_[(self->priv->selected_row * _tmp6__length2) + self->priv->selected_col];
#line 631 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (_tmp7_, TRUE);
#line 3506 "sudoku-view.c"
	}
}

static gboolean
sudoku_view_on_key_pressed (SudokuView* self,
                            GtkEventControllerKey* _key_controller,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean result;
#line 635 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 635 "../src/sudoku-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 637 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Left) {
#line 637 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3534 "sudoku-view.c"
	} else {
#line 637 "../src/sudoku-view.vala"
		_tmp1_ = keyval == GDK_KEY_KP_Left;
#line 3538 "sudoku-view.c"
	}
#line 637 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 637 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->selected_col == 0;
#line 3544 "sudoku-view.c"
	} else {
#line 637 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 3548 "sudoku-view.c"
	}
#line 637 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3552 "sudoku-view.c"
		SudokuCellView** _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		SudokuCellView* _tmp3_;
#line 639 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->cells;
#line 639 "../src/sudoku-view.vala"
		_tmp2__length1 = self->priv->cells_length1;
#line 639 "../src/sudoku-view.vala"
		_tmp2__length2 = self->priv->cells_length2;
#line 639 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_[(self->priv->selected_row * _tmp2__length2) + 8];
#line 639 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 640 "../src/sudoku-view.vala"
		result = TRUE;
#line 640 "../src/sudoku-view.vala"
		return result;
#line 3571 "sudoku-view.c"
	}
#line 643 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Right) {
#line 643 "../src/sudoku-view.vala"
		_tmp5_ = TRUE;
#line 3577 "sudoku-view.c"
	} else {
#line 643 "../src/sudoku-view.vala"
		_tmp5_ = keyval == GDK_KEY_KP_Right;
#line 3581 "sudoku-view.c"
	}
#line 643 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 643 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->selected_col == 8;
#line 3587 "sudoku-view.c"
	} else {
#line 643 "../src/sudoku-view.vala"
		_tmp4_ = FALSE;
#line 3591 "sudoku-view.c"
	}
#line 643 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 3595 "sudoku-view.c"
		SudokuCellView** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuCellView* _tmp7_;
#line 645 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 645 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 645 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 645 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_[(self->priv->selected_row * _tmp6__length2) + 0];
#line 645 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 646 "../src/sudoku-view.vala"
		result = TRUE;
#line 646 "../src/sudoku-view.vala"
		return result;
#line 3614 "sudoku-view.c"
	}
#line 649 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Up) {
#line 649 "../src/sudoku-view.vala"
		_tmp9_ = TRUE;
#line 3620 "sudoku-view.c"
	} else {
#line 649 "../src/sudoku-view.vala"
		_tmp9_ = keyval == GDK_KEY_KP_Up;
#line 3624 "sudoku-view.c"
	}
#line 649 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 649 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->selected_row == 0;
#line 3630 "sudoku-view.c"
	} else {
#line 649 "../src/sudoku-view.vala"
		_tmp8_ = FALSE;
#line 3634 "sudoku-view.c"
	}
#line 649 "../src/sudoku-view.vala"
	if (_tmp8_) {
#line 3638 "sudoku-view.c"
		SudokuCellView** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuCellView* _tmp11_;
#line 651 "../src/sudoku-view.vala"
		_tmp10_ = self->priv->cells;
#line 651 "../src/sudoku-view.vala"
		_tmp10__length1 = self->priv->cells_length1;
#line 651 "../src/sudoku-view.vala"
		_tmp10__length2 = self->priv->cells_length2;
#line 651 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_[(8 * _tmp10__length2) + self->priv->selected_col];
#line 651 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp11_);
#line 652 "../src/sudoku-view.vala"
		result = TRUE;
#line 652 "../src/sudoku-view.vala"
		return result;
#line 3657 "sudoku-view.c"
	}
#line 655 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Down) {
#line 655 "../src/sudoku-view.vala"
		_tmp13_ = TRUE;
#line 3663 "sudoku-view.c"
	} else {
#line 655 "../src/sudoku-view.vala"
		_tmp13_ = keyval == GDK_KEY_KP_Down;
#line 3667 "sudoku-view.c"
	}
#line 655 "../src/sudoku-view.vala"
	if (_tmp13_) {
#line 655 "../src/sudoku-view.vala"
		_tmp12_ = self->priv->selected_row == 8;
#line 3673 "sudoku-view.c"
	} else {
#line 655 "../src/sudoku-view.vala"
		_tmp12_ = FALSE;
#line 3677 "sudoku-view.c"
	}
#line 655 "../src/sudoku-view.vala"
	if (_tmp12_) {
#line 3681 "sudoku-view.c"
		SudokuCellView** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuCellView* _tmp15_;
#line 657 "../src/sudoku-view.vala"
		_tmp14_ = self->priv->cells;
#line 657 "../src/sudoku-view.vala"
		_tmp14__length1 = self->priv->cells_length1;
#line 657 "../src/sudoku-view.vala"
		_tmp14__length2 = self->priv->cells_length2;
#line 657 "../src/sudoku-view.vala"
		_tmp15_ = _tmp14_[(0 * _tmp14__length2) + self->priv->selected_col];
#line 657 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp15_);
#line 658 "../src/sudoku-view.vala"
		result = TRUE;
#line 658 "../src/sudoku-view.vala"
		return result;
#line 3700 "sudoku-view.c"
	}
#line 661 "../src/sudoku-view.vala"
	result = FALSE;
#line 661 "../src/sudoku-view.vala"
	return result;
#line 3706 "sudoku-view.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 664 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 664 "../src/sudoku-view.vala"
	return _data9_;
#line 3716 "sudoku-view.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 664 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 3726 "sudoku-view.c"
		SudokuView* self;
#line 664 "../src/sudoku-view.vala"
		self = _data9_->self;
#line 664 "../src/sudoku-view.vala"
		_g_object_unref0 (_data9_->game);
#line 664 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 664 "../src/sudoku-view.vala"
		g_slice_free (Block9Data, _data9_);
#line 3736 "sudoku-view.c"
	}
}

static gboolean
_sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                         cairo_t* cr,
                                         gpointer self)
{
	gboolean result;
	result = sudoku_view_draw_board ((SudokuView*) self, cr);
#line 674 "../src/sudoku-view.vala"
	return result;
#line 3749 "sudoku-view.c"
}

static void
__lambda13_ (SudokuView* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 681 "../src/sudoku-view.vala"
	_tmp0_ = self->game;
#line 681 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 681 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 681 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 3766 "sudoku-view.c"
		GtkDrawingArea* _tmp3_;
#line 682 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->drawing;
#line 682 "../src/sudoku-view.vala"
		gtk_widget_show ((GtkWidget*) _tmp3_);
#line 3772 "sudoku-view.c"
	} else {
		GtkDrawingArea* _tmp4_;
#line 684 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->drawing;
#line 684 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 3779 "sudoku-view.c"
	}
}

static void
___lambda13__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 680 "../src/sudoku-view.vala"
	__lambda13_ ((SudokuView*) self);
#line 3789 "sudoku-view.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 719 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 719 "../src/sudoku-view.vala"
	return _data10_;
#line 3799 "sudoku-view.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 719 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3809 "sudoku-view.c"
		SudokuView* self;
#line 719 "../src/sudoku-view.vala"
		self = _data10_->_data9_->self;
#line 719 "../src/sudoku-view.vala"
		_g_object_unref0 (_data10_->cell);
#line 719 "../src/sudoku-view.vala"
		block9_data_unref (_data10_->_data9_);
#line 719 "../src/sudoku-view.vala"
		_data10_->_data9_ = NULL;
#line 719 "../src/sudoku-view.vala"
		g_slice_free (Block10Data, _data10_);
#line 3821 "sudoku-view.c"
	}
}

static gboolean
________lambda14_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 725 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 725 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 726 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data9_->game);
#line 726 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 726 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 727 "../src/sudoku-view.vala"
		result = FALSE;
#line 727 "../src/sudoku-view.vala"
		return result;
#line 3847 "sudoku-view.c"
	}
#line 729 "../src/sudoku-view.vala"
	sudoku_view_set_selected (self, _data10_->cell_row, _data10_->cell_col);
#line 730 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 731 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 733 "../src/sudoku-view.vala"
	result = FALSE;
#line 733 "../src/sudoku-view.vala"
	return result;
#line 3859 "sudoku-view.c"
}

static gboolean
_________lambda14__gtk_widget_focus_in_event (GtkWidget* _sender,
                                              GdkEventFocus* event,
                                              gpointer self)
{
	gboolean result;
	result = ________lambda14_ (self);
#line 725 "../src/sudoku-view.vala"
	return result;
#line 3871 "sudoku-view.c"
}

static gboolean
________lambda15_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 736 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 736 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 737 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data9_->game);
#line 737 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 737 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 738 "../src/sudoku-view.vala"
		result = FALSE;
#line 738 "../src/sudoku-view.vala"
		return result;
#line 3896 "sudoku-view.c"
	}
#line 740 "../src/sudoku-view.vala"
	sudoku_view_set_selected (self, -1, -1);
#line 741 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 742 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 744 "../src/sudoku-view.vala"
	result = FALSE;
#line 744 "../src/sudoku-view.vala"
	return result;
#line 3908 "sudoku-view.c"
}

static gboolean
_________lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                               GdkEventFocus* event,
                                               gpointer self)
{
	gboolean result;
	result = ________lambda15_ (self);
#line 736 "../src/sudoku-view.vala"
	return result;
#line 3920 "sudoku-view.c"
}

static void
________lambda16_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	SudokuView* self;
	SudokuCellView* _tmp0_;
#line 749 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 749 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 750 "../src/sudoku-view.vala"
	_tmp0_ = _data10_->cell;
#line 750 "../src/sudoku-view.vala"
	sudoku_cell_view_long_press_event (_tmp0_);
#line 3937 "sudoku-view.c"
}

static void
_________lambda16__gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                   gdouble x,
                                                   gdouble y,
                                                   gpointer self)
{
#line 749 "../src/sudoku-view.vala"
	________lambda16_ (self);
#line 3948 "sudoku-view.c"
}

static void
________lambda17_ (Block10Data* _data10_,
                   GObject* s,
                   GParamSpec* p)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 753 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 753 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 753 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 753 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 754 "../src/sudoku-view.vala"
	if (self->priv->_show_possibilities) {
#line 754 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 3973 "sudoku-view.c"
	} else {
#line 754 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_show_warnings;
#line 3977 "sudoku-view.c"
	}
#line 754 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 754 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3983 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 754 "../src/sudoku-view.vala"
		_tmp3_ = _data9_->game->board;
#line 754 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
#line 754 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 754 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_;
#line 3996 "sudoku-view.c"
	}
#line 754 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 754 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 4002 "sudoku-view.c"
	} else {
#line 754 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->previous_board_broken_state;
#line 4006 "sudoku-view.c"
	}
#line 754 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 4010 "sudoku-view.c"
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 755 "../src/sudoku-view.vala"
		_tmp6_ = _data9_->game->board;
#line 755 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
#line 755 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 755 "../src/sudoku-view.vala"
		self->priv->previous_board_broken_state = _tmp8_;
#line 4022 "sudoku-view.c"
	}
#line 757 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 759 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 4028 "sudoku-view.c"
}

static void
_________lambda17__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 753 "../src/sudoku-view.vala"
	________lambda17_ (self, _sender, pspec);
#line 4038 "sudoku-view.c"
}

static gboolean
_sudoku_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_view_on_key_pressed ((SudokuView*) self, _sender, keyval, keycode, state);
#line 775 "../src/sudoku-view.vala"
	return result;
#line 4052 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block9Data* _data9_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkOverlay* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* _tmp4_;
	GtkGrid* _tmp5_;
	SudokuGame* _tmp8_;
	SudokuGame* _tmp9_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp10_;
	GtkCssProvider* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkGrid* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkCssProvider* _tmp21_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	SudokuBoard* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GtkGrid** _tmp28_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	SudokuBoard* _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	SudokuCellView** _tmp60_;
	GtkOverlay* _tmp100_;
	GtkDrawingArea* _tmp101_;
	GtkOverlay* _tmp102_;
	GtkGrid* _tmp103_;
	GtkGrid* _tmp104_;
	GtkOverlay* _tmp105_;
	GtkDrawingArea* _tmp106_;
	GtkEventControllerKey* _tmp107_;
	GtkEventControllerKey* _tmp108_;
#line 664 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 664 "../src/sudoku-view.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 664 "../src/sudoku-view.vala"
	_data9_->_ref_count_ = 1;
#line 664 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 664 "../src/sudoku-view.vala"
	_g_object_unref0 (_data9_->game);
#line 664 "../src/sudoku-view.vala"
	_data9_->game = _tmp0_;
#line 664 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 664 "../src/sudoku-view.vala"
	_data9_->self = g_object_ref (self);
#line 666 "../src/sudoku-view.vala"
	gtk_frame_set_shadow_type ((GtkFrame*) self, GTK_SHADOW_NONE);
#line 667 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "obey-child", FALSE, NULL);
#line 668 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "ratio", (gfloat) 1, NULL);
#line 670 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 670 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 670 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 670 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 671 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 671 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 673 "../src/sudoku-view.vala"
	_tmp3_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 673 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 673 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 673 "../src/sudoku-view.vala"
	self->priv->drawing = _tmp3_;
#line 674 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->drawing;
#line 674 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "draw", (GCallback) _sudoku_view_draw_board_gtk_widget_draw, self, 0);
#line 676 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->grid;
#line 676 "../src/sudoku-view.vala"
	if (_tmp5_ != NULL) {
#line 4158 "sudoku-view.c"
		GtkOverlay* _tmp6_;
		GtkGrid* _tmp7_;
#line 677 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->overlay;
#line 677 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->grid;
#line 677 "../src/sudoku-view.vala"
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 4167 "sudoku-view.c"
	}
#line 679 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_data9_->game);
#line 679 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 679 "../src/sudoku-view.vala"
	self->game = _tmp8_;
#line 680 "../src/sudoku-view.vala"
	_tmp9_ = self->game;
#line 680 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp9_, "paused-changed", (GCallback) ___lambda13__sudoku_game_paused_changed, self, 0);
#line 687 "../src/sudoku-view.vala"
	_tmp10_ = gtk_css_provider_new ();
#line 687 "../src/sudoku-view.vala"
	css_provider = _tmp10_;
#line 688 "../src/sudoku-view.vala"
	_tmp11_ = css_provider;
#line 688 "../src/sudoku-view.vala"
	gtk_css_provider_load_from_resource (_tmp11_, "/org/gnome/Sudoku/ui/gnome-sudoku.css");
#line 690 "../src/sudoku-view.vala"
	_tmp12_ = (GtkGrid*) gtk_grid_new ();
#line 690 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp12_);
#line 690 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 690 "../src/sudoku-view.vala"
	self->priv->grid = _tmp12_;
#line 691 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->grid;
#line 691 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp13_, 2);
#line 692 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->grid;
#line 692 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp14_, 2);
#line 693 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->grid;
#line 693 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp15_, TRUE);
#line 694 "../src/sudoku-view.vala"
	_tmp16_ = self->priv->grid;
#line 694 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp16_, TRUE);
#line 695 "../src/sudoku-view.vala"
	_tmp17_ = self->priv->grid;
#line 695 "../src/sudoku-view.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 695 "../src/sudoku-view.vala"
	gtk_style_context_add_class (_tmp18_, "board");
#line 696 "../src/sudoku-view.vala"
	_tmp19_ = self->priv->grid;
#line 696 "../src/sudoku-view.vala"
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _tmp19_);
#line 696 "../src/sudoku-view.vala"
	_tmp21_ = css_provider;
#line 696 "../src/sudoku-view.vala"
	gtk_style_context_add_provider (_tmp20_, (GtkStyleProvider*) _tmp21_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 698 "../src/sudoku-view.vala"
	_tmp22_ = _data9_->game->board;
#line 698 "../src/sudoku-view.vala"
	_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
#line 698 "../src/sudoku-view.vala"
	_tmp24_ = _tmp23_;
#line 698 "../src/sudoku-view.vala"
	_tmp25_ = _data9_->game->board;
#line 698 "../src/sudoku-view.vala"
	_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
#line 698 "../src/sudoku-view.vala"
	_tmp27_ = _tmp26_;
#line 698 "../src/sudoku-view.vala"
	_tmp28_ = g_new0 (GtkGrid*, (_tmp24_ * _tmp27_) + 1);
#line 698 "../src/sudoku-view.vala"
	blocks = _tmp28_;
#line 698 "../src/sudoku-view.vala"
	blocks_length1 = _tmp24_;
#line 698 "../src/sudoku-view.vala"
	blocks_length2 = _tmp27_;
#line 4245 "sudoku-view.c"
	{
		gint block_row = 0;
#line 699 "../src/sudoku-view.vala"
		block_row = 0;
#line 4250 "sudoku-view.c"
		{
			gboolean _tmp29_ = FALSE;
#line 699 "../src/sudoku-view.vala"
			_tmp29_ = TRUE;
#line 699 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4257 "sudoku-view.c"
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 699 "../src/sudoku-view.vala"
				if (!_tmp29_) {
#line 4263 "sudoku-view.c"
					gint _tmp30_;
#line 699 "../src/sudoku-view.vala"
					_tmp30_ = block_row;
#line 699 "../src/sudoku-view.vala"
					block_row = _tmp30_ + 1;
#line 4269 "sudoku-view.c"
				}
#line 699 "../src/sudoku-view.vala"
				_tmp29_ = FALSE;
#line 699 "../src/sudoku-view.vala"
				_tmp31_ = _data9_->game->board;
#line 699 "../src/sudoku-view.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 699 "../src/sudoku-view.vala"
				_tmp33_ = _tmp32_;
#line 699 "../src/sudoku-view.vala"
				if (!(block_row < _tmp33_)) {
#line 699 "../src/sudoku-view.vala"
					break;
#line 4283 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 701 "../src/sudoku-view.vala"
					block_col = 0;
#line 4289 "sudoku-view.c"
					{
						gboolean _tmp34_ = FALSE;
#line 701 "../src/sudoku-view.vala"
						_tmp34_ = TRUE;
#line 701 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4296 "sudoku-view.c"
							SudokuBoard* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkStyleContext* _tmp45_;
							GtkGrid* _tmp46_;
							GtkStyleContext* _tmp47_;
							GtkCssProvider* _tmp48_;
							GtkGrid* _tmp49_;
							GtkGrid* _tmp50_;
							GtkGrid** _tmp51_;
							gint _tmp51__length1;
							gint _tmp51__length2;
							GtkGrid* _tmp52_;
							GtkGrid* _tmp53_;
#line 701 "../src/sudoku-view.vala"
							if (!_tmp34_) {
#line 4320 "sudoku-view.c"
								gint _tmp35_;
#line 701 "../src/sudoku-view.vala"
								_tmp35_ = block_col;
#line 701 "../src/sudoku-view.vala"
								block_col = _tmp35_ + 1;
#line 4326 "sudoku-view.c"
							}
#line 701 "../src/sudoku-view.vala"
							_tmp34_ = FALSE;
#line 701 "../src/sudoku-view.vala"
							_tmp36_ = _data9_->game->board;
#line 701 "../src/sudoku-view.vala"
							_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
#line 701 "../src/sudoku-view.vala"
							_tmp38_ = _tmp37_;
#line 701 "../src/sudoku-view.vala"
							if (!(block_col < _tmp38_)) {
#line 701 "../src/sudoku-view.vala"
								break;
#line 4340 "sudoku-view.c"
							}
#line 703 "../src/sudoku-view.vala"
							_tmp39_ = (GtkGrid*) gtk_grid_new ();
#line 703 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp39_);
#line 703 "../src/sudoku-view.vala"
							block_grid = _tmp39_;
#line 704 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 704 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp40_, 1);
#line 705 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 705 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp41_, 1);
#line 706 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 706 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp42_, TRUE);
#line 707 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 707 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp43_, TRUE);
#line 708 "../src/sudoku-view.vala"
							_tmp44_ = block_grid;
#line 708 "../src/sudoku-view.vala"
							_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
#line 708 "../src/sudoku-view.vala"
							gtk_style_context_add_class (_tmp45_, "block");
#line 709 "../src/sudoku-view.vala"
							_tmp46_ = block_grid;
#line 709 "../src/sudoku-view.vala"
							_tmp47_ = gtk_widget_get_style_context ((GtkWidget*) _tmp46_);
#line 709 "../src/sudoku-view.vala"
							_tmp48_ = css_provider;
#line 709 "../src/sudoku-view.vala"
							gtk_style_context_add_provider (_tmp47_, (GtkStyleProvider*) _tmp48_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 710 "../src/sudoku-view.vala"
							_tmp49_ = self->priv->grid;
#line 710 "../src/sudoku-view.vala"
							_tmp50_ = block_grid;
#line 710 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, block_col, block_row, 1, 1);
#line 712 "../src/sudoku-view.vala"
							_tmp51_ = blocks;
#line 712 "../src/sudoku-view.vala"
							_tmp51__length1 = blocks_length1;
#line 712 "../src/sudoku-view.vala"
							_tmp51__length2 = blocks_length2;
#line 712 "../src/sudoku-view.vala"
							_tmp52_ = block_grid;
#line 712 "../src/sudoku-view.vala"
							_tmp53_ = _g_object_ref0 (_tmp52_);
#line 712 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp51_[(block_row * _tmp51__length2) + block_col]);
#line 712 "../src/sudoku-view.vala"
							_tmp51_[(block_row * _tmp51__length2) + block_col] = _tmp53_;
#line 701 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 4400 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 716 "../src/sudoku-view.vala"
	_tmp54_ = _data9_->game->board;
#line 716 "../src/sudoku-view.vala"
	_tmp55_ = sudoku_board_get_rows (_tmp54_);
#line 716 "../src/sudoku-view.vala"
	_tmp56_ = _tmp55_;
#line 716 "../src/sudoku-view.vala"
	_tmp57_ = _data9_->game->board;
#line 716 "../src/sudoku-view.vala"
	_tmp58_ = sudoku_board_get_cols (_tmp57_);
#line 716 "../src/sudoku-view.vala"
	_tmp59_ = _tmp58_;
#line 716 "../src/sudoku-view.vala"
	_tmp60_ = g_new0 (SudokuCellView*, (_tmp56_ * _tmp59_) + 1);
#line 716 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 716 "../src/sudoku-view.vala"
	self->priv->cells = _tmp60_;
#line 716 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp56_;
#line 716 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp59_;
#line 4429 "sudoku-view.c"
	{
		gint row = 0;
#line 717 "../src/sudoku-view.vala"
		row = 0;
#line 4434 "sudoku-view.c"
		{
			gboolean _tmp61_ = FALSE;
#line 717 "../src/sudoku-view.vala"
			_tmp61_ = TRUE;
#line 717 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4441 "sudoku-view.c"
				SudokuBoard* _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
#line 717 "../src/sudoku-view.vala"
				if (!_tmp61_) {
#line 4447 "sudoku-view.c"
					gint _tmp62_;
#line 717 "../src/sudoku-view.vala"
					_tmp62_ = row;
#line 717 "../src/sudoku-view.vala"
					row = _tmp62_ + 1;
#line 4453 "sudoku-view.c"
				}
#line 717 "../src/sudoku-view.vala"
				_tmp61_ = FALSE;
#line 717 "../src/sudoku-view.vala"
				_tmp63_ = _data9_->game->board;
#line 717 "../src/sudoku-view.vala"
				_tmp64_ = sudoku_board_get_rows (_tmp63_);
#line 717 "../src/sudoku-view.vala"
				_tmp65_ = _tmp64_;
#line 717 "../src/sudoku-view.vala"
				if (!(row < _tmp65_)) {
#line 717 "../src/sudoku-view.vala"
					break;
#line 4467 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 719 "../src/sudoku-view.vala"
					col = 0;
#line 4473 "sudoku-view.c"
					{
						gboolean _tmp66_ = FALSE;
#line 719 "../src/sudoku-view.vala"
						_tmp66_ = TRUE;
#line 719 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4480 "sudoku-view.c"
							Block10Data* _data10_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							SudokuCellView* _tmp71_;
							SudokuCellView* _tmp72_;
							SudokuCellView* _tmp73_;
							SudokuCellView* _tmp74_;
							SudokuCellView* _tmp75_;
							GtkGestureLongPress* _tmp76_;
							SudokuCellView* _tmp77_;
							GtkGestureLongPress* _tmp78_;
							SudokuCellView* _tmp79_;
							GtkGestureLongPress* _tmp80_;
							SudokuCellView* _tmp81_;
							SudokuCellView** _tmp82_;
							gint _tmp82__length1;
							gint _tmp82__length2;
							SudokuCellView* _tmp83_;
							SudokuCellView* _tmp84_;
							GtkGrid** _tmp85_;
							gint _tmp85__length1;
							gint _tmp85__length2;
							SudokuBoard* _tmp86_;
							gint _tmp87_;
							gint _tmp88_;
							SudokuBoard* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							GtkGrid* _tmp92_;
							SudokuCellView* _tmp93_;
							SudokuBoard* _tmp94_;
							gint _tmp95_;
							gint _tmp96_;
							SudokuBoard* _tmp97_;
							gint _tmp98_;
							gint _tmp99_;
#line 719 "../src/sudoku-view.vala"
							_data10_ = g_slice_new0 (Block10Data);
#line 719 "../src/sudoku-view.vala"
							_data10_->_ref_count_ = 1;
#line 719 "../src/sudoku-view.vala"
							_data10_->_data9_ = block9_data_ref (_data9_);
#line 719 "../src/sudoku-view.vala"
							if (!_tmp66_) {
#line 4526 "sudoku-view.c"
								gint _tmp67_;
#line 719 "../src/sudoku-view.vala"
								_tmp67_ = col;
#line 719 "../src/sudoku-view.vala"
								col = _tmp67_ + 1;
#line 4532 "sudoku-view.c"
							}
#line 719 "../src/sudoku-view.vala"
							_tmp66_ = FALSE;
#line 719 "../src/sudoku-view.vala"
							_tmp68_ = _data9_->game->board;
#line 719 "../src/sudoku-view.vala"
							_tmp69_ = sudoku_board_get_cols (_tmp68_);
#line 719 "../src/sudoku-view.vala"
							_tmp70_ = _tmp69_;
#line 719 "../src/sudoku-view.vala"
							if (!(col < _tmp70_)) {
#line 719 "../src/sudoku-view.vala"
								block10_data_unref (_data10_);
#line 719 "../src/sudoku-view.vala"
								_data10_ = NULL;
#line 719 "../src/sudoku-view.vala"
								break;
#line 4550 "sudoku-view.c"
							}
#line 721 "../src/sudoku-view.vala"
							_tmp71_ = sudoku_cell_view_new (row, col, &self->game);
#line 721 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp71_);
#line 721 "../src/sudoku-view.vala"
							_data10_->cell = _tmp71_;
#line 722 "../src/sudoku-view.vala"
							_data10_->cell_row = row;
#line 723 "../src/sudoku-view.vala"
							_data10_->cell_col = col;
#line 725 "../src/sudoku-view.vala"
							_tmp72_ = _data10_->cell;
#line 725 "../src/sudoku-view.vala"
							g_signal_connect_data ((GtkWidget*) _tmp72_, "focus-in-event", (GCallback) _________lambda14__gtk_widget_focus_in_event, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 736 "../src/sudoku-view.vala"
							_tmp73_ = _data10_->cell;
#line 736 "../src/sudoku-view.vala"
							g_signal_connect_data ((GtkWidget*) _tmp73_, "focus-out-event", (GCallback) _________lambda15__gtk_widget_focus_out_event, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 747 "../src/sudoku-view.vala"
							_tmp74_ = _data10_->cell;
#line 747 "../src/sudoku-view.vala"
							_tmp75_ = _data10_->cell;
#line 747 "../src/sudoku-view.vala"
							_tmp76_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ((GtkWidget*) _tmp75_);
#line 747 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp74_->long_press);
#line 747 "../src/sudoku-view.vala"
							_tmp74_->long_press = _tmp76_;
#line 748 "../src/sudoku-view.vala"
							_tmp77_ = _data10_->cell;
#line 748 "../src/sudoku-view.vala"
							_tmp78_ = _tmp77_->long_press;
#line 748 "../src/sudoku-view.vala"
							gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp78_, GTK_PHASE_TARGET);
#line 749 "../src/sudoku-view.vala"
							_tmp79_ = _data10_->cell;
#line 749 "../src/sudoku-view.vala"
							_tmp80_ = _tmp79_->long_press;
#line 749 "../src/sudoku-view.vala"
							g_signal_connect_data (_tmp80_, "pressed", (GCallback) _________lambda16__gtk_gesture_long_press_pressed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 753 "../src/sudoku-view.vala"
							_tmp81_ = _data10_->cell;
#line 753 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp81_, "notify::value", (GCallback) _________lambda17__g_object_notify, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 762 "../src/sudoku-view.vala"
							_tmp82_ = self->priv->cells;
#line 762 "../src/sudoku-view.vala"
							_tmp82__length1 = self->priv->cells_length1;
#line 762 "../src/sudoku-view.vala"
							_tmp82__length2 = self->priv->cells_length2;
#line 762 "../src/sudoku-view.vala"
							_tmp83_ = _data10_->cell;
#line 762 "../src/sudoku-view.vala"
							_tmp84_ = _g_object_ref0 (_tmp83_);
#line 762 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp82_[(row * _tmp82__length2) + col]);
#line 762 "../src/sudoku-view.vala"
							_tmp82_[(row * _tmp82__length2) + col] = _tmp84_;
#line 764 "../src/sudoku-view.vala"
							_tmp85_ = blocks;
#line 764 "../src/sudoku-view.vala"
							_tmp85__length1 = blocks_length1;
#line 764 "../src/sudoku-view.vala"
							_tmp85__length2 = blocks_length2;
#line 764 "../src/sudoku-view.vala"
							_tmp86_ = _data9_->game->board;
#line 764 "../src/sudoku-view.vala"
							_tmp87_ = sudoku_board_get_block_rows (_tmp86_);
#line 764 "../src/sudoku-view.vala"
							_tmp88_ = _tmp87_;
#line 764 "../src/sudoku-view.vala"
							_tmp89_ = _data9_->game->board;
#line 764 "../src/sudoku-view.vala"
							_tmp90_ = sudoku_board_get_block_cols (_tmp89_);
#line 764 "../src/sudoku-view.vala"
							_tmp91_ = _tmp90_;
#line 764 "../src/sudoku-view.vala"
							_tmp92_ = _tmp85_[((row / _tmp88_) * _tmp85__length2) + (col / _tmp91_)];
#line 764 "../src/sudoku-view.vala"
							_tmp93_ = _data10_->cell;
#line 764 "../src/sudoku-view.vala"
							_tmp94_ = _data9_->game->board;
#line 764 "../src/sudoku-view.vala"
							_tmp95_ = sudoku_board_get_block_cols (_tmp94_);
#line 764 "../src/sudoku-view.vala"
							_tmp96_ = _tmp95_;
#line 764 "../src/sudoku-view.vala"
							_tmp97_ = _data9_->game->board;
#line 764 "../src/sudoku-view.vala"
							_tmp98_ = sudoku_board_get_block_rows (_tmp97_);
#line 764 "../src/sudoku-view.vala"
							_tmp99_ = _tmp98_;
#line 764 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, col % _tmp96_, row % _tmp99_, 1, 1);
#line 719 "../src/sudoku-view.vala"
							block10_data_unref (_data10_);
#line 719 "../src/sudoku-view.vala"
							_data10_ = NULL;
#line 4650 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 768 "../src/sudoku-view.vala"
	_tmp100_ = self->priv->overlay;
#line 768 "../src/sudoku-view.vala"
	_tmp101_ = self->priv->drawing;
#line 768 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp100_, (GtkWidget*) _tmp101_);
#line 769 "../src/sudoku-view.vala"
	_tmp102_ = self->priv->overlay;
#line 769 "../src/sudoku-view.vala"
	_tmp103_ = self->priv->grid;
#line 769 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp102_, (GtkWidget*) _tmp103_);
#line 770 "../src/sudoku-view.vala"
	_tmp104_ = self->priv->grid;
#line 770 "../src/sudoku-view.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp104_);
#line 771 "../src/sudoku-view.vala"
	_tmp105_ = self->priv->overlay;
#line 771 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp105_);
#line 772 "../src/sudoku-view.vala"
	_tmp106_ = self->priv->drawing;
#line 772 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp106_);
#line 774 "../src/sudoku-view.vala"
	_tmp107_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 774 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 774 "../src/sudoku-view.vala"
	self->priv->key_controller = _tmp107_;
#line 775 "../src/sudoku-view.vala"
	_tmp108_ = self->priv->key_controller;
#line 775 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp108_, "key-pressed", (GCallback) _sudoku_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 664 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 664 "../src/sudoku-view.vala"
	_g_object_unref0 (css_provider);
#line 664 "../src/sudoku-view.vala"
	block9_data_unref (_data9_);
#line 664 "../src/sudoku-view.vala"
	_data9_ = NULL;
#line 664 "../src/sudoku-view.vala"
	return self;
#line 4701 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game)
{
#line 664 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game);
#line 4709 "sudoku-view.c"
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
#line 778 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 780 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 780 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->selected_col >= 0;
#line 4724 "sudoku-view.c"
	} else {
#line 780 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 4728 "sudoku-view.c"
	}
#line 780 "../src/sudoku-view.vala"
	has_selection = _tmp0_;
#line 781 "../src/sudoku-view.vala"
	cell_value = -1;
#line 782 "../src/sudoku-view.vala"
	if (has_selection) {
#line 4736 "sudoku-view.c"
		SudokuCellView** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCellView* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 783 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 783 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 783 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 783 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->priv->selected_row * _tmp1__length2) + self->priv->selected_col];
#line 783 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_value (_tmp2_);
#line 783 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 783 "../src/sudoku-view.vala"
		cell_value = _tmp4_;
#line 4757 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 785 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 4763 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 785 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 785 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4770 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 785 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 4777 "sudoku-view.c"
					gint _tmp6_;
#line 785 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 785 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 4783 "sudoku-view.c"
				}
#line 785 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 785 "../src/sudoku-view.vala"
				_tmp7_ = self->game;
#line 785 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_->board;
#line 785 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
#line 785 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 785 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp10_)) {
#line 785 "../src/sudoku-view.vala"
					break;
#line 4799 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 787 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 4805 "sudoku-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 787 "../src/sudoku-view.vala"
						_tmp11_ = TRUE;
#line 787 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4812 "sudoku-view.c"
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_ = FALSE;
							SudokuCellView** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							SudokuCellView* _tmp39_;
							gboolean _tmp40_ = FALSE;
							gboolean _tmp41_ = FALSE;
							SudokuCellView** _tmp46_;
							gint _tmp46__length1;
							gint _tmp46__length2;
							SudokuCellView* _tmp47_;
#line 787 "../src/sudoku-view.vala"
							if (!_tmp11_) {
#line 4831 "sudoku-view.c"
								gint _tmp12_;
#line 787 "../src/sudoku-view.vala"
								_tmp12_ = row_tmp;
#line 787 "../src/sudoku-view.vala"
								row_tmp = _tmp12_ + 1;
#line 4837 "sudoku-view.c"
							}
#line 787 "../src/sudoku-view.vala"
							_tmp11_ = FALSE;
#line 787 "../src/sudoku-view.vala"
							_tmp13_ = self->game;
#line 787 "../src/sudoku-view.vala"
							_tmp14_ = _tmp13_->board;
#line 787 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_board_get_rows (_tmp14_);
#line 787 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 787 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp16_)) {
#line 787 "../src/sudoku-view.vala"
								break;
#line 4853 "sudoku-view.c"
							}
#line 789 "../src/sudoku-view.vala"
							if (has_selection) {
#line 789 "../src/sudoku-view.vala"
								_tmp18_ = self->priv->_highlighter;
#line 4859 "sudoku-view.c"
							} else {
#line 789 "../src/sudoku-view.vala"
								_tmp18_ = FALSE;
#line 4863 "sudoku-view.c"
							}
#line 789 "../src/sudoku-view.vala"
							if (_tmp18_) {
#line 4867 "sudoku-view.c"
								gboolean _tmp19_ = FALSE;
								gboolean _tmp20_ = FALSE;
#line 790 "../src/sudoku-view.vala"
								if (col_tmp == self->priv->selected_col) {
#line 790 "../src/sudoku-view.vala"
									_tmp20_ = TRUE;
#line 4874 "sudoku-view.c"
								} else {
#line 791 "../src/sudoku-view.vala"
									_tmp20_ = row_tmp == self->priv->selected_row;
#line 4878 "sudoku-view.c"
								}
#line 789 "../src/sudoku-view.vala"
								if (_tmp20_) {
#line 790 "../src/sudoku-view.vala"
									_tmp19_ = TRUE;
#line 4884 "sudoku-view.c"
								} else {
									gboolean _tmp21_ = FALSE;
									SudokuGame* _tmp22_;
									SudokuBoard* _tmp23_;
									gint _tmp24_;
									gint _tmp25_;
									SudokuGame* _tmp26_;
									SudokuBoard* _tmp27_;
									gint _tmp28_;
									gint _tmp29_;
#line 792 "../src/sudoku-view.vala"
									_tmp22_ = self->game;
#line 792 "../src/sudoku-view.vala"
									_tmp23_ = _tmp22_->board;
#line 792 "../src/sudoku-view.vala"
									_tmp24_ = sudoku_board_get_block_cols (_tmp23_);
#line 792 "../src/sudoku-view.vala"
									_tmp25_ = _tmp24_;
#line 792 "../src/sudoku-view.vala"
									_tmp26_ = self->game;
#line 792 "../src/sudoku-view.vala"
									_tmp27_ = _tmp26_->board;
#line 792 "../src/sudoku-view.vala"
									_tmp28_ = sudoku_board_get_block_cols (_tmp27_);
#line 792 "../src/sudoku-view.vala"
									_tmp29_ = _tmp28_;
#line 792 "../src/sudoku-view.vala"
									if ((col_tmp / _tmp25_) == (self->priv->selected_col / _tmp29_)) {
#line 4913 "sudoku-view.c"
										SudokuGame* _tmp30_;
										SudokuBoard* _tmp31_;
										gint _tmp32_;
										gint _tmp33_;
										SudokuGame* _tmp34_;
										SudokuBoard* _tmp35_;
										gint _tmp36_;
										gint _tmp37_;
#line 793 "../src/sudoku-view.vala"
										_tmp30_ = self->game;
#line 793 "../src/sudoku-view.vala"
										_tmp31_ = _tmp30_->board;
#line 793 "../src/sudoku-view.vala"
										_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 793 "../src/sudoku-view.vala"
										_tmp33_ = _tmp32_;
#line 793 "../src/sudoku-view.vala"
										_tmp34_ = self->game;
#line 793 "../src/sudoku-view.vala"
										_tmp35_ = _tmp34_->board;
#line 793 "../src/sudoku-view.vala"
										_tmp36_ = sudoku_board_get_block_rows (_tmp35_);
#line 793 "../src/sudoku-view.vala"
										_tmp37_ = _tmp36_;
#line 793 "../src/sudoku-view.vala"
										_tmp21_ = (row_tmp / _tmp33_) == (self->priv->selected_row / _tmp37_);
#line 4940 "sudoku-view.c"
									} else {
#line 792 "../src/sudoku-view.vala"
										_tmp21_ = FALSE;
#line 4944 "sudoku-view.c"
									}
#line 792 "../src/sudoku-view.vala"
									_tmp19_ = _tmp21_;
#line 4948 "sudoku-view.c"
								}
#line 789 "../src/sudoku-view.vala"
								_tmp17_ = _tmp19_;
#line 4952 "sudoku-view.c"
							} else {
#line 789 "../src/sudoku-view.vala"
								_tmp17_ = FALSE;
#line 4956 "sudoku-view.c"
							}
#line 789 "../src/sudoku-view.vala"
							_tmp38_ = self->priv->cells;
#line 789 "../src/sudoku-view.vala"
							_tmp38__length1 = self->priv->cells_length1;
#line 789 "../src/sudoku-view.vala"
							_tmp38__length2 = self->priv->cells_length2;
#line 789 "../src/sudoku-view.vala"
							_tmp39_ = _tmp38_[(row_tmp * _tmp38__length2) + col_tmp];
#line 789 "../src/sudoku-view.vala"
							sudoku_cell_view_set_highlighted_background (_tmp39_, _tmp17_);
#line 795 "../src/sudoku-view.vala"
							if (has_selection) {
#line 796 "../src/sudoku-view.vala"
								_tmp41_ = self->priv->_highlighter;
#line 4972 "sudoku-view.c"
							} else {
#line 795 "../src/sudoku-view.vala"
								_tmp41_ = FALSE;
#line 4976 "sudoku-view.c"
							}
#line 795 "../src/sudoku-view.vala"
							if (_tmp41_) {
#line 4980 "sudoku-view.c"
								SudokuCellView** _tmp42_;
								gint _tmp42__length1;
								gint _tmp42__length2;
								SudokuCellView* _tmp43_;
								gint _tmp44_;
								gint _tmp45_;
#line 797 "../src/sudoku-view.vala"
								_tmp42_ = self->priv->cells;
#line 797 "../src/sudoku-view.vala"
								_tmp42__length1 = self->priv->cells_length1;
#line 797 "../src/sudoku-view.vala"
								_tmp42__length2 = self->priv->cells_length2;
#line 797 "../src/sudoku-view.vala"
								_tmp43_ = _tmp42_[(row_tmp * _tmp42__length2) + col_tmp];
#line 797 "../src/sudoku-view.vala"
								_tmp44_ = sudoku_cell_view_get_value (_tmp43_);
#line 797 "../src/sudoku-view.vala"
								_tmp45_ = _tmp44_;
#line 797 "../src/sudoku-view.vala"
								_tmp40_ = cell_value == _tmp45_;
#line 5001 "sudoku-view.c"
							} else {
#line 795 "../src/sudoku-view.vala"
								_tmp40_ = FALSE;
#line 5005 "sudoku-view.c"
							}
#line 795 "../src/sudoku-view.vala"
							_tmp46_ = self->priv->cells;
#line 795 "../src/sudoku-view.vala"
							_tmp46__length1 = self->priv->cells_length1;
#line 795 "../src/sudoku-view.vala"
							_tmp46__length2 = self->priv->cells_length2;
#line 795 "../src/sudoku-view.vala"
							_tmp47_ = _tmp46_[(row_tmp * _tmp46__length2) + col_tmp];
#line 795 "../src/sudoku-view.vala"
							sudoku_cell_view_set_highlighted_value (_tmp47_, _tmp40_);
#line 5017 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static gboolean
sudoku_view_draw_board (SudokuView* self,
                        cairo_t* c)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 802 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 802 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 804 "../src/sudoku-view.vala"
	_tmp0_ = self->game;
#line 804 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 804 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 804 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 5046 "sudoku-view.c"
		gint board_length = 0;
		GtkGrid* _tmp3_;
		gchar* text = NULL;
		gchar* _tmp4_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp5_;
		cairo_text_extents_t _tmp6_ = {0};
		cairo_text_extents_t _tmp7_;
		cairo_text_extents_t _tmp8_;
		const gchar* _tmp9_;
#line 806 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->grid;
#line 806 "../src/sudoku-view.vala"
		board_length = gtk_widget_get_allocated_width ((GtkWidget*) _tmp3_);
#line 808 "../src/sudoku-view.vala"
		cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 809 "../src/sudoku-view.vala"
		cairo_paint (c);
#line 811 "../src/sudoku-view.vala"
		cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 812 "../src/sudoku-view.vala"
		cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 815 "../src/sudoku-view.vala"
		_tmp4_ = g_strdup (_ ("Paused"));
#line 815 "../src/sudoku-view.vala"
		text = _tmp4_;
#line 817 "../src/sudoku-view.vala"
		_tmp5_ = text;
#line 817 "../src/sudoku-view.vala"
		cairo_text_extents (c, _tmp5_, &_tmp6_);
#line 817 "../src/sudoku-view.vala"
		extents = _tmp6_;
#line 818 "../src/sudoku-view.vala"
		_tmp7_ = extents;
#line 818 "../src/sudoku-view.vala"
		_tmp8_ = extents;
#line 818 "../src/sudoku-view.vala"
		cairo_move_to (c, (board_length / 2.0) - (_tmp7_.width / 2.0), (board_length / 2.0) + (_tmp8_.height / 2.0));
#line 819 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 820 "../src/sudoku-view.vala"
		_tmp9_ = text;
#line 820 "../src/sudoku-view.vala"
		cairo_show_text (c, _tmp9_);
#line 804 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 5093 "sudoku-view.c"
	}
#line 823 "../src/sudoku-view.vala"
	result = FALSE;
#line 823 "../src/sudoku-view.vala"
	return result;
#line 5099 "sudoku-view.c"
}

void
sudoku_view_clear (SudokuView* self)
{
#line 826 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 5107 "sudoku-view.c"
	{
		gint i = 0;
#line 828 "../src/sudoku-view.vala"
		i = 0;
#line 5112 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 828 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 828 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5119 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 828 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5126 "sudoku-view.c"
					gint _tmp1_;
#line 828 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 828 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5132 "sudoku-view.c"
				}
#line 828 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 828 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 828 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 828 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 828 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 828 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 828 "../src/sudoku-view.vala"
					break;
#line 5148 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 829 "../src/sudoku-view.vala"
					j = 0;
#line 5154 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 829 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 829 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5161 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 829 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5172 "sudoku-view.c"
								gint _tmp7_;
#line 829 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 829 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5178 "sudoku-view.c"
							}
#line 829 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 829 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 829 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 829 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 829 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 829 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 829 "../src/sudoku-view.vala"
								break;
#line 5194 "sudoku-view.c"
							}
#line 830 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 830 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 830 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 830 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 830 "../src/sudoku-view.vala"
							sudoku_cell_view_clear (_tmp13_);
#line 5206 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_hide_popovers (SudokuView* self)
{
#line 890 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 5220 "sudoku-view.c"
	{
		gint i = 0;
#line 892 "../src/sudoku-view.vala"
		i = 0;
#line 5225 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 892 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 892 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5232 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 892 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5239 "sudoku-view.c"
					gint _tmp1_;
#line 892 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 892 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5245 "sudoku-view.c"
				}
#line 892 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 892 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 892 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 892 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 892 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 892 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 892 "../src/sudoku-view.vala"
					break;
#line 5261 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 893 "../src/sudoku-view.vala"
					j = 0;
#line 5267 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 893 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 893 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5274 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 893 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5285 "sudoku-view.c"
								gint _tmp7_;
#line 893 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 893 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5291 "sudoku-view.c"
							}
#line 893 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 893 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 893 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 893 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 893 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 893 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 893 "../src/sudoku-view.vala"
								break;
#line 5307 "sudoku-view.c"
							}
#line 894 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 894 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 894 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 894 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 894 "../src/sudoku-view.vala"
							sudoku_cell_view_hide_both_popovers (_tmp13_);
#line 5319 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 836 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 836 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 836 "../src/sudoku-view.vala"
	return result;
#line 5338 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 837 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 838 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 5349 "sudoku-view.c"
	{
		gint i = 0;
#line 839 "../src/sudoku-view.vala"
		i = 0;
#line 5354 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 839 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 839 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5361 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 839 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5368 "sudoku-view.c"
					gint _tmp1_;
#line 839 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 839 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5374 "sudoku-view.c"
				}
#line 839 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 839 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 839 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 839 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 839 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 839 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 839 "../src/sudoku-view.vala"
					break;
#line 5390 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 840 "../src/sudoku-view.vala"
					j = 0;
#line 5396 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 840 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 840 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5403 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 840 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5414 "sudoku-view.c"
								gint _tmp7_;
#line 840 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 840 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5420 "sudoku-view.c"
							}
#line 840 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 840 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 840 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 840 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 840 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 840 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 840 "../src/sudoku-view.vala"
								break;
#line 5436 "sudoku-view.c"
							}
#line 841 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 841 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 841 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 841 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 841 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_warnings (_tmp13_, self->priv->_show_warnings);
#line 5448 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 837 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 5457 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 848 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 848 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 848 "../src/sudoku-view.vala"
	return result;
#line 5470 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
#line 849 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 850 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 5481 "sudoku-view.c"
	{
		gint i = 0;
#line 851 "../src/sudoku-view.vala"
		i = 0;
#line 5486 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 851 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 851 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5493 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 851 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5500 "sudoku-view.c"
					gint _tmp1_;
#line 851 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 851 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5506 "sudoku-view.c"
				}
#line 851 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 851 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 851 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 851 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 851 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 851 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 851 "../src/sudoku-view.vala"
					break;
#line 5522 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 852 "../src/sudoku-view.vala"
					j = 0;
#line 5528 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 852 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 852 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5535 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 852 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5546 "sudoku-view.c"
								gint _tmp7_;
#line 852 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 852 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5552 "sudoku-view.c"
							}
#line 852 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 852 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 852 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 852 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 852 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 852 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 852 "../src/sudoku-view.vala"
								break;
#line 5568 "sudoku-view.c"
							}
#line 853 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 853 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 853 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 853 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 853 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_extra_warnings (_tmp13_, self->priv->_show_extra_warnings);
#line 5580 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 849 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 5589 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 860 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 860 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 860 "../src/sudoku-view.vala"
	return result;
#line 5602 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 861 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 862 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 5613 "sudoku-view.c"
	{
		gint i = 0;
#line 863 "../src/sudoku-view.vala"
		i = 0;
#line 5618 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 863 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 863 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5625 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 863 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5632 "sudoku-view.c"
					gint _tmp1_;
#line 863 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 863 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5638 "sudoku-view.c"
				}
#line 863 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 863 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 863 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 863 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 863 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 863 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 863 "../src/sudoku-view.vala"
					break;
#line 5654 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 864 "../src/sudoku-view.vala"
					j = 0;
#line 5660 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 864 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 864 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5667 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 864 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5678 "sudoku-view.c"
								gint _tmp7_;
#line 864 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 864 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5684 "sudoku-view.c"
							}
#line 864 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 864 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 864 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 864 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 864 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 864 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 864 "../src/sudoku-view.vala"
								break;
#line 5700 "sudoku-view.c"
							}
#line 865 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 865 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 865 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 865 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 865 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_possibilities (_tmp13_, value);
#line 5712 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 861 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 5721 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 872 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 872 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 872 "../src/sudoku-view.vala"
	return result;
#line 5734 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 873 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 874 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 5745 "sudoku-view.c"
	{
		gint i = 0;
#line 875 "../src/sudoku-view.vala"
		i = 0;
#line 5750 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 875 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 875 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5757 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 875 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5764 "sudoku-view.c"
					gint _tmp1_;
#line 875 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 875 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5770 "sudoku-view.c"
				}
#line 875 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 875 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 875 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 875 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 875 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 875 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 875 "../src/sudoku-view.vala"
					break;
#line 5786 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 876 "../src/sudoku-view.vala"
					j = 0;
#line 5792 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 876 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 876 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5799 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 876 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5810 "sudoku-view.c"
								gint _tmp7_;
#line 876 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 876 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5816 "sudoku-view.c"
							}
#line 876 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 876 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 876 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 876 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 876 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 876 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 876 "../src/sudoku-view.vala"
								break;
#line 5832 "sudoku-view.c"
							}
#line 877 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 877 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 877 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 877 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 877 "../src/sudoku-view.vala"
							sudoku_cell_view_set_initialize_earmarks (_tmp13_, value);
#line 5844 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 873 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 5853 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 884 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 884 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 884 "../src/sudoku-view.vala"
	return result;
#line 5866 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 885 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 886 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 885 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 5879 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
#line 605 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 605 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 605 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 605 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 605 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 605 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 605 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 605 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 605 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 605 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5906 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 605 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 610 "../src/sudoku-view.vala"
	self->priv->previous_board_broken_state = FALSE;
#line 618 "../src/sudoku-view.vala"
	self->priv->selected_row = -1;
#line 619 "../src/sudoku-view.vala"
	self->priv->selected_col = -1;
#line 833 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 845 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 857 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 869 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 881 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 5931 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 605 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 607 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 608 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 612 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 613 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 614 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 616 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 605 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 5954 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (gtk_aspect_frame_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 605 "../src/sudoku-view.vala"
	switch (property_id) {
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 605 "../src/sudoku-view.vala"
		break;
#line 6019 "sudoku-view.c"
		default:
#line 605 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 605 "../src/sudoku-view.vala"
		break;
#line 6025 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 605 "../src/sudoku-view.vala"
	switch (property_id) {
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 605 "../src/sudoku-view.vala"
		break;
#line 605 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 605 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 605 "../src/sudoku-view.vala"
		break;
#line 6069 "sudoku-view.c"
		default:
#line 605 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 605 "../src/sudoku-view.vala"
		break;
#line 6075 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

